import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["В нетривиальных задачах нам может пригодиться удалять отслеживание ", jsx(_components.code, {
        children: "Сигналов"
      }), ", даже в реактивной парадигме. В Solid для этого существует функция-помощник ", jsx(_components.code, {
        children: "untrack"
      }), " которая позволяет удалить отслеживание любых чтений."]
    }), "\n", jsxs(_components.p, {
      children: ["Предположим, мы не хотим регистрироваться на обновление ", jsx(_components.code, {
        children: "Сигнала"
      }), " ", jsx(_components.code, {
        children: "b"
      }), ". Мы можем убрать отслеживание ", jsx(_components.code, {
        children: "Сигнала"
      }), " ", jsx(_components.code, {
        children: "b"
      }), ", изменив наш эффект на следующий:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "(), ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "untrack"
        }), "(b));\n});\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Поскольку ", jsx(_components.code, {
        children: "Сигналы"
      }), " являются функциями, их можно передавать напрямую, но ", jsx(_components.code, {
        children: "untrack"
      }), " может оборачивать функции с более сложным поведением."]
    }), "\n", jsxs(_components.p, {
      children: ["Несмотря на то, что ", jsx(_components.code, {
        children: "untrack"
      }), " отключает отслеживание чтений, это никак не влияет на оповещения при записи, которые все еще будут уведомлять наблюдателей."]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-03be0d13.js.map
