import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["フレームワークの中には、クリーンアップメソッドを副作用やライフサイクルメソッドの戻り値として組み合わせているものもあります。Solid のレンダーツリー内のすべてのものは、（おそらく不活性な）Effect の中に存在し、ネストできるので、", jsx(_components.code, {
        children: "onCleanup"
      }), " をファーストクラスのメソッドにしました。任意のスコープでこのメソッドを呼び出すことができ、そのスコープが再評価のトリガーを受けたときや、最終的に廃棄されたときに実行されます。"]
    }), "\n", jsx(_components.p, {
      children: "コンポーネントや Effect の中で使用してください。また、カスタムディレクティブにも使用できます。リアクティブシステムの同期実行の一部となるものであれば、どこでも使用できます。"
    }), "\n", jsxs(_components.p, {
      children: ["はじめに紹介した Signal の例では、自分自身の後始末をしませんでした。", jsx(_components.code, {
        children: "setInterval"
      }), " の呼び出しを次のように置き換えて修正しましょう:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " timer = ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "setInterval"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "() + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), "), ", jsx(_components.span, {
          className: "hljs-number",
          children: "1000"
        }), ");\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "clearInterval"
        }), "(timer));\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-03dc1b51.js.map
