import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "При создании приложений вы захотите разбить код на части для лучшей модульности и возможности повторного использования. В Solid основной способ сделать это — создавать компоненты."
    }), "\n", jsxs(_components.p, {
      children: ["Компоненты — это просто функции, подобные функции ", jsx(_components.code, {
        children: "HelloWorld()"
      }), ", которую мы использовали до сих пор. Что делает их особенными, так это то, что они обычно возвращают JSX и могут вызываться с помощью JSX в других компонентах."]
    }), "\n", jsxs(_components.p, {
      children: ["В этом примере давайте добавим наш компонент ", jsx(_components.code, {
        children: "Nested"
      }), " в наше приложение. Мы определили его в другом файле (вы можете поместить несколько компонентов в один файл если вам это необходимо). Сначала мы должны импортировать его:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Nested"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'./nested'"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Затем нам нужно добавить компонент в наш JSX. Как и раньше, у нас есть несколько элементов, которые мы хотим вернуть, поэтому мы оборачиваем их во Фрагмент:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "App"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n\t", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\n\t\t", jsxs(_components.span, {
          className: "xml",
          children: [jsx(_components.span, {
            className: "hljs-tag",
            children: "<>"
          }), "\n\t\t\t", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "This is a Header", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "\n\t\t\t", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Nested"
            }), " />"]
          }), "\n\t\t", jsx(_components.span, {
            className: "hljs-tag",
            children: "</>"
          })]
        }), "\n\t);\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Когда родительский компонент впервые отрисовывается, он выполнит функцию ", jsx(_components.code, {
        children: "Nested()"
      }), " и больше не будет вызывать ее. Все обновления контролируются системой реактивности Solid, о которой мы расскажем в следующих уроках."]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-1bc0d3e8.js.map
