import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["Для удобства Solid имеет функцию-помощник ", jsx(_components.code, {
        children: "on"
      }), ", который позволяет указывать зависимости для наших вычислений явно. Это в основном используется как способ явно указать, какие ", jsx(_components.code, {
        children: "Сигналы"
      }), " должны отслеживаться (и прекратить отслеживать любые другие ", jsx(_components.code, {
        children: "Сигналы"
      }), ", даже если они прочитаны). Кроме того, on предоставляет параметр ", jsx(_components.code, {
        children: "defer"
      }), ", который позволяет вычислению не выполняться немедленно, а запускаться только при первом изменении."]
    }), "\n", jsxs(_components.p, {
      children: ["Давайте запустим наш ", jsx(_components.code, {
        children: "Эффект"
      }), " только при обновлении ", jsx(_components.code, {
        children: "a"
      }), " и отложим выполнение до изменения значения:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "a"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(a, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "());\n}, { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defer"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), " }));\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-2f439d68.js.map
