import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span",
    em: "em",
    blockquote: "blockquote",
    a: "a"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "Сигналы"
      }), " — это отслеживаемые значения, но они — только половина уравнения. В дополнение к ним есть наблюдатели, которые могут быть обновлены этими отслеживаемыми значениями. ", jsx(_components.code, {
        children: "Эффект"
      }), " — один из таких наблюдателей; у него есть побочный эффект, зависящий от ", jsx(_components.code, {
        children: "Сигналов"
      }), "."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "Эффект"
      }), " можно создать, импортировав ", jsx(_components.code, {
        children: "createEffect"
      }), " из ", jsx(_components.code, {
        children: "solid-js"
      }), " и предоставив ему функцию. Эффект автоматически подписывается на любой ", jsx(_components.code, {
        children: "Cигнал"
      }), ", который считывается во время выполнения функции, и перезапускается при изменении любого из них."]
    }), "\n", jsxs(_components.p, {
      children: ["Итак, давайте создадим ", jsx(_components.code, {
        children: "Эффект"
      }), ", который будет запускаться повторно при изменении ", jsx(_components.code, {
        children: "count"
      }), ":"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n\t", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'The count is now'"
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "());\n});\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Чтобы обновлять наш ", jsx(_components.code, {
        children: "Сигнал"
      }), " ", jsx(_components.code, {
        children: "count"
      }), ", прикрепим обработчик кликов к нашей кнопке:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<button onClick={", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "() + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ")}>", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Click"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Me"
        }), "</button>\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Теперь нажатие на кнопку добавит нам лог в консоль. Это относительно простой пример, но чтобы понять, как работает Solid, вы должны представить, что каждое выражение в JSX — это самостоятельный Эффект, который повторно выполняется при изменении зависимых ", jsx(_components.code, {
        children: "Сигналов"
      }), ". Вот как весь рендеринг работает в Solid: с точки зрения Solid, ", jsx(_components.em, {
        children: "весь рендеринг — это всего лишь побочный эффект реактивной системы"
      }), "."]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: ["Эффекты, которые разработчики создают с помощью ", jsx(_components.code, {
          children: "createEffect"
        }), ", запускаются после завершения рендеринга и в основном используются для планирования обновлений, которые взаимодействуют с DOM. Если вы хотите изменить DOM раньше, используйте [", jsx(_components.code, {
          children: "createRenderEffect"
        }), "] (", jsx(_components.a, {
          href: "https://www.solidjs.com/docs/latest/api#createrendereffect",
          children: "https://www.solidjs.com/docs/latest/api#createrendereffect"
        }), ")."]
      }), "\n"]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-40137360.js.map
