import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "JSX で Signal にアクセスすると、その Signal が変化したときに自動的にビューが更新されることを見てきました。しかし、コンポーネント関数自体は一度しか実行されません。"
    }), "\n", jsx(_components.p, {
      children: "Signal を関数でラップすることで、Signal に依存する新しい式を作ることができます。Signal にアクセスする関数は、実質的に Signal でもあります。ラップされた Signal が変化すると、読み込み側も更新されます。"
    }), "\n", jsxs(_components.p, {
      children: ["それでは、", jsx(_components.code, {
        children: "doubleCount"
      }), " 関数を導入して、2 倍カウントするように Counter を更新してみましょう:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "doubleCount"
        }), " = (", jsx(_components.span, {
          className: "hljs-params"
        }), ") => ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "() * ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["そして、JSX の中で Signal のように ", jsx(_components.code, {
        children: "doubleCount"
      }), " を呼び出すことができます:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Count: {doubleCount()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "このような関数を「派生 Signal」と呼ぶのは、アクセスする Signal からリアクティビティを得るためです。派生 Signal は、それ自体が値を格納するわけではありません（派生 Signal を作成しても一度も呼び出さなければ、未使用の関数と同様に Solid の出力から取り除かれます）が、派生 Signal に依存する Effect を更新したり、ビューに含まれている場合には再レンダリングをトリガーします。"
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-53f728d7.js.map
