import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "Seiring kamu membuat aplikasi, kamu ingin memecah kode kamu untuk modularitas dan reusabilitas yang lebih baik. Di Solid, cara utama untuk melakukan itu adalah membuat komponen."
    }), "\n", jsxs(_components.p, {
      children: ["Komponen itu hanya sebuah satu-satunya fungsi seperti ", jsx(_components.code, {
        children: "HelloWorld()"
      }), " yang kita gunakan seajuh ini. Apa yang membuat mereka spesial biasanya mengembalikan JSX dan bisa dipanggil JSX di komponen lain."]
    }), "\n", jsxs(_components.p, {
      children: ["Dalam contoh ini, kita coba tambahkan komponen ", jsx(_components.code, {
        children: "Nested"
      }), " kedalam aplikasi kita. Kita akan mendefinisikannya di file lain, meskipun kamu bisa menuliskannya di file yang sama. Pertama kita harus mengimportnya:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Nested"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./nested\""
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Kemudian kita butuh menambahkan komponen kedalam JSX kita. Sama seperti sebelumnya, kita sekarang memiliki banyak elemen yang kita mau untuk kembalikan, jadi bungkus elemen-elemen tersebut kedalam Fragment:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "App"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsx(_components.span, {
            className: "hljs-tag",
            children: "<>"
          }), "\n      ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "This is a Header", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "\n      ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Nested"
            }), " />"]
          }), "\n    ", jsx(_components.span, {
            className: "hljs-tag",
            children: "</>"
          })]
        }), "\n  );\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Ketika komponen parent melakukan render untuk pertama kalinya, peristiwa itu akan mengeksekusi fungsi ", jsx(_components.code, {
        children: "Nested()"
      }), " dan tidak akan memanggilnya lagi. Semua pembaruan yang diterapkan oleh Sistem Reaktivitas Solid akan kita bahas dalam beberapa materi selanjutnya."]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-600603a5.js.map
