import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "Manchmal unterstützen die eigenen Komponenten eine variable Zahl an Attributen und es macht daher Sinn, diese als Objekt statt einzeln zu übergeben. Das ist besonders dann der Fall, wenn man ein DOM-Element in eine Komponente kapselt, eine gängige Praxis in Design-Systemen."
    }), "\n", jsxs(_components.p, {
      children: ["Für diesen Fall können wir den Spread-Operator verwenden ", jsx(_components.code, {
        children: "..."
      }), "."]
    }), "\n", jsx(_components.p, {
      children: "Wir können damit ein Objekt mit einer beliebigen Zahl von Eigenschaften übergeben:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Info"
        }), " {...pkg} />\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-6bd140f5.js.map
