import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "Реактивность Solid является синхронной, что означает, что после любого изменения DOM будет обновлен. Это отлично работает в случае с Solid так как все обновления в нём являются точными. Если наши несвязные компоненты будут зарендерены дважды на самом деле не означают потраченную впустую работу."
    }), "\n", jsxs(_components.p, {
      children: ["Но что делать в случае, если изменения связаны? Для этого в Solid есть функция ", jsx(_components.code, {
        children: "batch"
      }), ". Она позволяет поставить в очередь несколько изменений, а затем применить их все одновременно, прежде чем уведомить своих наблюдателей (", jsx(_components.code, {
        children: "observers"
      }), "). Мы можем представить эту операцию как транзакцию, в которой обновленные значения ", jsx(_components.code, {
        children: "Сигналов"
      }), " не фиксируются до завершения."]
    }), "\n", jsxs(_components.p, {
      children: ["В этом примере мы назначаем оба имени по нажатию кнопки, и это дважды запускает обновление UI. Вы можете увидеть это в консоли, нажав на кнопку. Итак, давайте объединим вызовы ", jsx(_components.code, {
        children: "set"
      }), " в ", jsx(_components.code, {
        children: "batch"
      }), ":"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [" ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "updateNames"
        }), " = (", jsx(_components.span, {
          className: "hljs-params"
        }), ") => {\n    ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Button Clicked\""
        }), ");\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "batch"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setFirstName"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "firstName"
        }), "() + ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"n\""
        }), ");\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setLastName"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "lastName"
        }), "() + ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"!\""
        }), ");\n    })\n  }\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Этого достаточно для того, чтобы оптимизировать данный пример. Теперь DOM будет обновлен только один раз."
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-81e76155.js.map
