import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["Некоторые фреймворки связывают методы очистки с методами обновления и не рассматривают их как отдельное состояние жизненного цикла. Поскольку все в дереве рендеринга Solid живет внутри Эффекта и может быть вложенным, мы выделили метод ", jsx(_components.code, {
        children: "onCleanup"
      }), " для удобства использования при очистке. Вы можете вызвать его в любом скоупе, и он будет запущен, когда этот скоуп будет изменен или удален."]
    }), "\n", jsx(_components.p, {
      children: "Его можно использовать в компонентах, Эффектах, кастомных директивах — практически в любом синхронном реактивном коде."
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "Сигнал"
      }), " в примере из введения так и не прибрался за собой. Давайте исправим это, заменив вызов ", jsx(_components.code, {
        children: "setInterval"
      }), " следующим:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " timer = ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "setInterval"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "() + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), "), ", jsx(_components.span, {
          className: "hljs-number",
          children: "1000"
        }), ");\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "clearInterval"
        }), "(timer));\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-b7c855f2.js.map
