import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span",
    em: "em"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["Kamu sudah tahu cara merender daftar di Solid menggunakan ", jsx(_components.code, {
        children: "<For>"
      }), ", tetapi Solid juga memiliki komponen ", jsx(_components.code, {
        children: "<Index>"
      }), ", yang akan menyebabkan lebih sedikit perenderan ulang dalam situasi tertentu."]
    }), "\n", jsxs(_components.p, {
      children: ["Saat array diperbarui, komponen ", jsx(_components.code, {
        children: "<For>"
      }), " menggunakan persamaan referensial untuk membandingkan elemen dengan status terakhir array. Tapi ini tidak selalu diinginkan."]
    }), "\n", jsxs(_components.p, {
      children: ["Dalam JavaScript, primitif (seperti string dan angka) selalu dibandingkan berdasarkan nilai. Saat menggunakan ", jsx(_components.code, {
        children: "<For>"
      }), " dengan nilai primitif atau array dari array, ini dapat menyebabkan banyak rendering yang tidak perlu. Jika menggunakan ", jsx(_components.code, {
        children: "<For>"
      }), " untuk memetakan daftar string ke bidang ", jsx(_components.code, {
        children: "<input>"
      }), " yang dapat diedit masing-masing, ", jsx(_components.code, {
        children: "<input>"
      }), " akan dibuat ulang setiap kali kamu mengubah nilai tersebut."]
    }), "\n", jsxs(_components.p, {
      children: ["Komponen ", jsx(_components.code, {
        children: "<Index>"
      }), " disediakan untuk kasus ini. Sebagai aturan praktis, gunakan ", jsx(_components.code, {
        children: "<Index>"
      }), " ketika berhadapan dengan primitif."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={", jsx(_components.span, {
          className: "hljs-title function_",
          children: "cats"
        }), "()}>{", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "cat, i"
          }), ") =>"]
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "a"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "target"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "\"_blank\""
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "href"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "`", jsx(_components.span, {
              className: "hljs-attr",
              children: "https:"
            }), "//", jsx(_components.span, {
              className: "hljs-attr",
              children: "www.youtube.com"
            }), "/", jsx(_components.span, {
              className: "hljs-attr",
              children: "watch"
            }), "?", jsx(_components.span, {
              className: "hljs-attr",
              children: "v"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "${cat().id}"
            }), "`}>"]
          }), "\n      {i + 1}: {cat().name}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "a"
            }), ">"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          })]
        }), "\n}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Ini mirip dengan ", jsx(_components.code, {
        children: "<For>"
      }), ", tetapi kali ini itemnya adalah ", jsx(_components.em, {
        children: "signal"
      }), " dan indeksnya tetap. Setiap node yang dirender sesuai dengan tempat dalam array. ", jsx(_components.em, {
        children: "Signal"
      }), " akan diperbarui setiap kali data di tempat itu berubah."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<For>"
      }), " menangani setiap bagian data dalam array, dan posisi data tersebut dapat berubah; ", jsx(_components.code, {
        children: "<Index>"
      }), " bekerja dengan setiap indeks dalam array, dan konten di setiap indeks dapat berubah."]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-ef2d4c81.js.map
