import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["JSX erlaubt es uns, JavaScript zu verwenden, um den logischen Ablauf in einem Template zu kontrollieren. Allerdings führt die naive Nutzung von Methoden wie ", jsx(_components.code, {
        children: "Array.prototype.map"
      }), " ohne ein virtuelles DOM dazu, dass verschwenderischerweise bei jeder Aktualisierung alle DOM-Nodes neu erstellt werden. Stattdessen ist es in reaktiven Libraries gängig, Template-Helfer zu verwenden. In Solid sind diese in Komponenten verpackt."]
    }), "\n", jsxs(_components.p, {
      children: ["Der einfachste Kontrollfluss ist die Bedingung. Solids Compiler ist intelligent genug, um ternäre Ausdrücke (", jsx(_components.code, {
        children: "a ? b : c"
      }), ") und bool'sche Ausdrücke (", jsx(_components.code, {
        children: "a && b"
      }), ") optimal zu handhaben. Allerdings ist es häufig lesbarer, Solids ", jsx(_components.code, {
        children: "<Show>"
      }), "-Komponente zu nutzen."]
    }), "\n", jsx(_components.p, {
      children: "In dem Beispiel soll nur der Knopf gezeigt werden, der dem gegenwärtigen Zustand (ob der Nutzer eingeloggt ist) entspricht. Ändere das JSX zu:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), "\n  when={", jsx(_components.span, {
          className: "hljs-title function_",
          children: "loggedIn"
        }), "()}\n  fallback={", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{toggle}"
            }), ">"]
          }), "Log in", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), ">"]
          })]
        }), "}\n>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{toggle}"
            }), ">"]
          }), "Log out", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Das ", jsx(_components.code, {
        children: "fallback"
      }), "-Prop fungiert als ", jsx(_components.code, {
        children: "else"
      }), " und wird angezeigt, wenn die Bedingung, die an ", jsx(_components.code, {
        children: "when"
      }), " übergeben wird, keinen ", jsx(_components.code, {
        children: "true"
      }), " entsprechenden Wert enthält."]
    }), "\n", jsx(_components.p, {
      children: "Jetzt wird das Drücken auf den Knopf dessen Zustand wie erwartet ändern."
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-f48c3bce.js.map
