import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [{
  "depth": 1,
  "value": "Réactivité basique",
  "children": [{
    "depth": 2,
    "value": "createSignal",
    "children": []
  }, {
    "depth": 2,
    "value": "createEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createMemo",
    "children": []
  }, {
    "depth": 2,
    "value": "createResource",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Cycles de vie",
  "children": [{
    "depth": 2,
    "value": "onMount",
    "children": []
  }, {
    "depth": 2,
    "value": "onCleanup",
    "children": []
  }, {
    "depth": 2,
    "value": "onError",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Utilitaires réactifs",
  "children": [{
    "depth": 2,
    "value": "untrack",
    "children": []
  }, {
    "depth": 2,
    "value": "batch",
    "children": []
  }, {
    "depth": 2,
    "value": "on",
    "children": []
  }, {
    "depth": 2,
    "value": "createRoot",
    "children": []
  }, {
    "depth": 2,
    "value": "mergeProps",
    "children": []
  }, {
    "depth": 2,
    "value": "splitProps",
    "children": []
  }, {
    "depth": 2,
    "value": "useTransition",
    "children": []
  }, {
    "depth": 2,
    "value": "observable",
    "children": []
  }, {
    "depth": 2,
    "value": "mapArray",
    "children": []
  }, {
    "depth": 2,
    "value": "indexArray",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Stores",
  "children": [{
    "depth": 2,
    "value": "createStore",
    "children": [{
      "depth": 3,
      "value": "Getters",
      "children": []
    }, {
      "depth": 3,
      "value": "Updating Stores",
      "children": []
    }]
  }, {
    "depth": 2,
    "value": "produce",
    "children": []
  }, {
    "depth": 2,
    "value": "reconcile",
    "children": []
  }, {
    "depth": 2,
    "value": "createMutable",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "APIs de Composant",
  "children": [{
    "depth": 2,
    "value": "createContext",
    "children": []
  }, {
    "depth": 2,
    "value": "useContext",
    "children": []
  }, {
    "depth": 2,
    "value": "children",
    "children": []
  }, {
    "depth": 2,
    "value": "lazy",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Primitives secondaires",
  "children": [{
    "depth": 2,
    "value": "createDeferred",
    "children": []
  }, {
    "depth": 2,
    "value": "createComputed",
    "children": []
  }, {
    "depth": 2,
    "value": "createRenderEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createSelector",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Rendering",
  "children": []
}, {
  "depth": 1,
  "value": "Rendu",
  "children": [{
    "depth": 2,
    "value": "render",
    "children": []
  }, {
    "depth": 2,
    "value": "hydrate",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToString",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToStringAsync",
    "children": []
  }, {
    "depth": 2,
    "value": "pipeToNodeWritable",
    "children": []
  }, {
    "depth": 2,
    "value": "pipeToWritable",
    "children": []
  }, {
    "depth": 2,
    "value": "isServer",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Control Flow",
  "children": [{
    "depth": 2,
    "value": "<For>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Show>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Switch>/<Match>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Index>",
    "children": []
  }, {
    "depth": 2,
    "value": "<ErrorBoundary>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Suspense>",
    "children": []
  }, {
    "depth": 2,
    "value": "<SuspenseList> (Expérimental)",
    "children": []
  }, {
    "depth": 2,
    "value": "<Dynamic>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Portal>",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Attributs JSX spéciaux",
  "children": [{
    "depth": 2,
    "value": "ref",
    "children": []
  }, {
    "depth": 2,
    "value": "classList",
    "children": []
  }, {
    "depth": 2,
    "value": "style",
    "children": []
  }, {
    "depth": 2,
    "value": "innerHTML/textContent",
    "children": []
  }, {
    "depth": 2,
    "value": "on___",
    "children": []
  }, {
    "depth": 2,
    "value": "on:___/oncapture:___",
    "children": []
  }, {
    "depth": 2,
    "value": "use:___",
    "children": []
  }, {
    "depth": 2,
    "value": "prop:___",
    "children": []
  }, {
    "depth": 2,
    "value": "attr:___",
    "children": []
  }, {
    "depth": 2,
    "value": "/* @once */",
    "children": []
  }]
}];
function _createMdxContent(props) {
  const _components = Object.assign({
    h1: "h1",
    a: "a",
    h2: "h2",
    code: "code",
    pre: "pre",
    span: "span",
    p: "p",
    blockquote: "blockquote",
    h3: "h3",
    strong: "strong"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.h1, {
      id: "réactivité-basique",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#réactivité-basique",
        children: "#"
      }), "Réactivité basique"]
    }), "\n", jsxs(_components.h2, {
      id: "createsignal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createsignal",
        children: "#"
      }), jsx(_components.code, {
        children: "createSignal"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSignal<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "value"
        }), ": T,\r\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "; equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\r\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "C'est la primitive réactive la plus basique utilisée pour surveiller une seule valeur qui change dans le temps. La fonction de création retourne une paire de fonctions, une pour la lecture de la valeur et l'autre pour mettre à jour le signal."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [getValue, setValue] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(initialValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// lecture de la valeur"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getValue"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// met à jour la valeur"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setValue"
        }), "(nextValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// met à jour une valeur avec une fonction incluant la valeur précédente"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setValue"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " prev + next);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["N'oubliez pas d'accéder aux signaux sous une portée surveillée si vous souhaitez qu'elles soient réactives à la mise à jour. Les portées surveillées sont des fonctions qui sont passées à des évaluations comme ", jsx(_components.code, {
        children: "createEffect"
      }), " ou des expressions JSX."]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "Si vous souhaitez stocker une fonction dans un Signal, vous devez utiliser la forme suivante :"
      }), "\n", jsx(_components.pre, {
        children: jsxs(_components.code, {
          className: "hljs language-js",
          children: [jsx(_components.span, {
            className: "hljs-title function_",
            children: "setValue"
          }), "(", jsx(_components.span, {
            className: "hljs-function",
            children: "() =>"
          }), " myFunction);\n"]
        })
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "createeffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createeffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createEffect<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\r\n  value?: T,\r\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\r\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Créer un nouveau calcul qui va automatiquement surveiller ses dépendances et s'exécuter après chaque rendu où les dépendances ont été changées. Ceci est idéal pour l'utilisation de ", jsx(_components.code, {
        children: "ref"
      }), "s et la gestion d'autres effets secondaires."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [a, setA] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(initialValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// L'effet va dépendre du signal `a`"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "doSideEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "()));\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "La fonction effet est appelée avec la valeur retournée par la dernière exécution de la fonction passée en argument. Cette valeur peut être initialisée en tant que 2ème argument optionnel. Cela peut être utile lors de comparaison sans créer une fonction supplémentaire."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " sum = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "() + ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (sum !== prev) ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(sum);\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " sum;\r\n}, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "creatememo",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#creatememo",
        children: "#"
      }), jsx(_components.code, {
        children: "createMemo"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMemo<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\r\n  value?: T,\r\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "; equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Créer une valeur dérivée d'un signal qui ne peut pas être modifié directement, elle recalcule sa valeur lorsque les dépendances du code sont mise à jour."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " getValue = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "computeExpensiveValue"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "(), ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// lecture de la valeur"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getValue"
        }), "();\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "La fonction mémo est appelée avec une valeur retournée depuis la dernière exécution de la fonction mémo. Cette valeur peut être initialisée optionnellement en tant que 2ème argument. Cela est utile pour réduire le nombre de calculs."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " sum = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "input"
        }), "() + prev, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createresource",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createresource",
        children: "#"
      }), jsx(_components.code, {
        children: "createResource"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T> = [\r\n  {\r\n    (): T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "loading"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "error"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\r\n  },\r\n  {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mutate"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "refetch"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n  }\r\n];\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ">(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["k: U, getPrev: () => T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\r\n  options?: { initialValue?: T; name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), "),\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["k: U, getPrev: () => T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\r\n  options?: { initialValue?: T; name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Créer un signal qui peut gérer des requêtes asynchrones. ", jsx(_components.code, {
        children: "fetcher"
      }), " est une fonction asynchrone qui accepte une valeur retournée par la ", jsx(_components.code, {
        children: "source"
      }), " si elle est fournie et qu'elle retourne une Promesse dont la valeur renvoyée est stockée dans la ressource. La fonction de récupération (fetcher) n'est pas réactive, donc utilisez le premier argument optionnel si vous voulez l'exécuter plus d'une fois. Si la source retourne une valeur ", jsx(_components.code, {
        children: "false"
      }), ", ", jsx(_components.code, {
        children: "null"
      }), " ou ", jsx(_components.code, {
        children: "undefined"
      }), " alors elle ne sera pas récupérée."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [data, { mutate, refetch }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(getQuery, fetchData);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// lire la valeur"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "data"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// vérifier si la valeur est en chargement"
        }), "\r\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "loading"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// vérifier si des erreurs sont apparues lors de la récupération"
        }), "\r\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "error"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// directly set value without creating promise"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// met à jour la valeur sans créer de promesse"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mutate"
        }), "(optimisticValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// réexécute la requête pour certain cas"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "refetch"
        }), "();\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "loading"
      }), " et ", jsx(_components.code, {
        children: "error"
      }), " sont des propriétés réactives qui peuvent être surveillées."]
    }), "\n", jsxs(_components.h1, {
      id: "cycles-de-vie",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#cycles-de-vie",
        children: "#"
      }), "Cycles de vie"]
    }), "\n", jsxs(_components.h2, {
      id: "onmount",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onmount",
        children: "#"
      }), jsx(_components.code, {
        children: "onMount"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Programme une méthode qui va s'exécuter après le rendu initial et que les éléments soient monté. C'est idéal pour utiliser des ", jsx(_components.code, {
        children: "ref"
      }), "s et gérer d'autres effets secondaires qui ne doivent s'exécuter qu'une seule fois. C'est l'équivalent de ", jsx(_components.code, {
        children: "createEffect"
      }), " sans dépendances."]
    }), "\n", jsxs(_components.h2, {
      id: "oncleanup",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#oncleanup",
        children: "#"
      }), jsx(_components.code, {
        children: "onCleanup"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Programme une méthode de nettoyage qui s'exécute à la destruction ou recalcule de la portée réactive actuelle. Peut être utilisé dans n'importe quel Composant ou Effet."
    }), "\n", jsxs(_components.h2, {
      id: "onerror",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onerror",
        children: "#"
      }), jsx(_components.code, {
        children: "onError"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onError"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: (err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ") => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Programme une méthode de gestion d'erreur qui va s'exécuter lorsque la portée enfant lève une erreur. Seulement la portée la plus proche de l'erreur va exécuter sa fonction de gestion d'erreur. Si une erreur se reproduit, la fonction se réexécute."
    }), "\n", jsxs(_components.h1, {
      id: "utilitaires-réactifs",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#utilitaires-réactifs",
        children: "#"
      }), "Utilitaires réactifs"]
    }), "\n", jsx(_components.p, {
      children: "Ce sont des fonctions d'aide qui permettent de mieux gérer la planification des mises à jour et de contrôler comment la réactivité est gérée."
    }), "\n", jsxs(_components.h2, {
      id: "untrack",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#untrack",
        children: "#"
      }), jsx(_components.code, {
        children: "untrack"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " untrack<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Ignore le suivi des dépendances dans le bloc de code exécuté et retourne la valeur."
    }), "\n", jsxs(_components.h2, {
      id: "batch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#batch",
        children: "#"
      }), jsx(_components.code, {
        children: "batch"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " batch<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Groupe les mises à jour dans le bloc jusqu'à la fin pour éviter des calculs inutiles. Cela veut dire que la lecture des valeurs dans les lignes suivantes ne seront pas à jour. Les ", jsx(_components.a, {
        href: "https://www.solidjs.com/docs/latest/api#createstore",
        children: "Stores de Solid"
      }), " utilise cette méthode pour affecter des valeurs et les Effets enrobent automatiquement leur code dans un ", jsx(_components.code, {
        children: "batch"
      }), "."]
    }), "\n", jsxs(_components.h2, {
      id: "on",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on",
        children: "#"
      }), jsx(_components.code, {
        children: "on"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " on<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "> | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "), U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "deps"
        }), ": T,\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "input: T, prevInput: T, prevValue?: U"
          }), ") =>"]
        }), " U,\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "options"
        }), ": { defer?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), " } = {}\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prevValue?: U"
          }), ") =>"]
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "on"
      }), " est fait pour passer dans une fonction de calcul qui va rendre ses dépendances explicites. Si un tableau de dépendances est passé, ", jsx(_components.code, {
        children: "input"
      }), " et ", jsx(_components.code, {
        children: "prevInput"
      }), " sont des tableaux."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "())));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// est l'équivalent de:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " v = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "untrack"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\r\n});\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Vous pouvez aussi ne pas exécuter le calcul immédiatement et à la place choisir de l'exécuter au changement en passant l'option de ", jsx(_components.code, {
        children: "defer: true"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Ne s'exécute pas immédiatement"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v), { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defer"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), " }));\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setA"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"new\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Maintenant elle s'exécute"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createroot",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createroot",
        children: "#"
      }), jsx(_components.code, {
        children: "createRoot"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRoot<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["dispose: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Créer un nouveau contexte qui ne sera pas surveillé et qui ne se détruira pas automatiquement. C'est utile pour les contextes réactifs imbriqués que vous ne voulez pas détruire lorsque le parent se réévalue. C'est un pattern puissant pour mettre en cache des données."
    }), "\n", jsxs(_components.p, {
      children: ["Tous les projets Solid devraient être enrobés de cette fonction à haut niveau pour s'assurer que toute la mémoire/calcul soit libérée. Normalement, vous n'avez à vous soucier de ceci, car ", jsx(_components.code, {
        children: "createRoot"
      }), " est embarqué dans la fonction d'entrée ", jsx(_components.code, {
        children: "render"
      }), "."]
    }), "\n", jsxs(_components.h2, {
      id: "mergeprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#mergeprops",
        children: "#"
      }), jsx(_components.code, {
        children: "mergeProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["...sources: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Une méthode ", jsx(_components.code, {
        children: "merge"
      }), " qui va fusionner des objets réactifs. C'est utile pour associer des valeurs par défaut aux props de composants dans le cas où le parent ne les fournit pas. Ou cloner l'objet props en incluant des propriétés réactives."]
    }), "\n", jsx(_components.p, {
      children: "Cette méthode fonctionne en utilisant les proxies et associant les propriétés dans l'ordre inverse. Cela permet de dynamiquement surveiller les propriétés qui ne sont pas présentes quand l'objet prop est fusionné la première fois."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// props par défault"
        }), "\r\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "name"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), " }, props);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// cloner l'objet props"
        }), "\r\nnewProps = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(props);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// fusionner l'objet props"
        }), "\r\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(props, otherProps);\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "splitprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#splitprops",
        children: "#"
      }), jsx(_components.code, {
        children: "splitProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " splitProps<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T,\r\n  ...", jsx(_components.span, {
          className: "hljs-attr",
          children: "keys"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<(keyof T)[]>\r\n): [...", jsx(_components.span, {
          className: "hljs-attr",
          children: "parts"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Partial"
        }), "<T>];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "C'est un remplacement de la déstructuration. Elle va séparer un objet réactif par une liste de clés pour maintenir la réactivité."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [local, others] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "splitProps"
        }), "(props, [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"children\""
        }), "]);\r\n\r\n<>\r\n  <Child {...others} />\r\n  <div>{local.children}<div>\r\n</>\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "usetransition",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usetransition",
        children: "#"
      }), jsx(_components.code, {
        children: "useTransition"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), "): [\r\n  ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ",\r\n  ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["fn: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), ", cb?: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), "\r\n];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Utilisé pour grouper les mises à jour asynchrones dans une transition qui va reporter les changements jusqu'à ce que tous les processus asynchrones soient complétés. Ceci est lié au Suspense et surveille seulement les ressources lues dans les limites des Suspenses."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [isPending, start] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Vérifie si entrain de transitionner."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "isPending"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Enrobe dans une transition"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "start"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setSignal"
        }), "(newValue), ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/* la transition est terminée */"
        }), ")\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "observable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#observable",
        children: "#"
      }), jsx(_components.code, {
        children: "observable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " observable<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "input"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Observable"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Cette méthode prend un signal et produit un simple objet Observable. Vous pouvez l'utiliser avec une librairie Observable de votre choix typiquement avec l'opérateur ", jsx(_components.code, {
        children: "from"
      }), "."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"rxjs\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [s, set] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " obsv$ = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "from"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "observable"
        }), "(s));\r\n\r\nobsv$.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "maparray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#maparray",
        children: "#"
      }), jsx(_components.code, {
        children: "mapArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " mapArray<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T, i: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Fonction d'aide d'association réactive qui va mettre en cache chaque élément par référence pour réduire les associations inutiles lors de mise à jour. Elle ne va exécuter la fonction d'association qu'une fois par valeur et va la déplacer ou supprimer en fonction du besoin. L'argument index est un signal. La fonction d'association elle-même n'est pas surveillée."
    }), "\n", jsxs(_components.p, {
      children: ["Cette fonction d'aide est utilisée pour le contrôle de flux avec ", jsx(_components.code, {
        children: "<For />"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mapArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "model"
          }), ") =>"]
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [name, setName] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(model.", jsx(_components.span, {
          className: "hljs-property",
          children: "name"
        }), ");\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [description, setDescription] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(model.", jsx(_components.span, {
          className: "hljs-property",
          children: "description"
        }), ");\r\n\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": model.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "name"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "name"
        }), "();\r\n    },\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "description"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "description"
        }), "();\r\n    }\r\n    setName,\r\n    setDescription\r\n  }\r\n});\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "indexarray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#indexarray",
        children: "#"
      }), jsx(_components.code, {
        children: "indexArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " indexArray<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: () => T, i: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Similaire à ", jsx(_components.code, {
        children: "mapArray"
      }), " sauf qu'elle associe par index. L'élément est un signal et l'index est maintenant une constante."]
    }), "\n", jsxs(_components.p, {
      children: ["Cette fonction d'aide est utilisée pour le contrôle de flux avec ", jsx(_components.code, {
        children: "<Index />"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "indexArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "model"
          }), ") =>"]
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "id"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "firstInitial"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), "[", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "];\r\n    },\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${model().firstName}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${model().lastName}"
          }), "`"]
        }), ";\r\n    },\r\n  }\r\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "stores",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#stores",
        children: "#"
      }), "Stores"]
    }), "\n", jsxs(_components.p, {
      children: ["Ces APIs sont disponibles sous ", jsx(_components.code, {
        children: "solid-js/store"
      }), "."]
    }), "\n", jsxs(_components.h2, {
      id: "createstore",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createstore",
        children: "#"
      }), jsx(_components.code, {
        children: "createStore"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createStore<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\r\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\r\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SetStoreFunction"
        }), "<T>];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Cette fonction va créer un arbre de Signaux en tant que proxy pour permettre des valeurs individuelles dans une structure de données imbriquées d'être indépendamment surveillé. La fonction de création retourne un objet proxy en lecture seule et une fonction de mise à jour."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "(initialValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Lis une valeur"
        }), "\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// met à jour une valeur"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "merge"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"thisValue\""
        }), " });\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"path\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"to\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"value\""
        }), ", newValue);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Les objets Store sont des proxies qui sont surveillés seulement sur l'accès aux propriétés. Et à l'accès, les Stores produisent récursivement des objets Store imbriqués sur les données imbriquées. Cependant, ça ne peut enrober que des tableaux et de simples objets. Les classes ne sont pas enrobées. Donc les ", jsx(_components.code, {
        children: "Date"
      }), ", ", jsx(_components.code, {
        children: "HTMLElement"
      }), ", ", jsx(_components.code, {
        children: "RegExp"
      }), ", ", jsx(_components.code, {
        children: "Map"
      }), ", ", jsx(_components.code, {
        children: "Set"
      }), " ne sont pas réactifs. De plus, les objets de haut niveau ne peuvent pas être surveillés sans accéder à une de leurs propriétés. Donc il ne convient pas de les utiliser pour des éléments sur lesquels on va itérer, car l'ajout de nouvelles clés ou d'index ne va pas engendrer une mise à jour. Donc mettez vos listes dans une clé de votre état au lieu d'essayer d'utiliser l'objet état directement."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// mettez la liste dans une clé sur l'objet store"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": [] });\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// accéder à la propriété `list` sur l'objet état"
        }), "\r\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.list}"
            }), ">"]
          }), "{item => /*...*/}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), "\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "getters",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#getters",
        children: "#"
      }), "Getters"]
    }), "\n", jsx(_components.p, {
      children: "Les objets Store supportent l'utilisation d'accesseur pour calculer des valeurs."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".firstName}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".lastName}"]
          }), "`"]
        }), ";\r\n    },\r\n  },\r\n});\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Ce sont de simples accesseurs, donc vous avez besoin d'utiliser Mémo si vous souhaitez garder en cache la valeur ;"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " fullName;\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "();\r\n    },\r\n  },\r\n});\r\nfullName = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.user.firstName}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.user.lastName}"
          }), "`"]
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "updating-stores",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#updating-stores",
        children: "#"
      }), "Updating Stores"]
    }), "\n", jsxs(_components.p, {
      children: ["Les changements peuvent prendre la forme de fonction qui passe en paramètre la valeur de l'état précédent et retourne un nouvel état ou une valeur. Les objets sont toujours superficiellement fusionnés. Affecter une valeur ", jsx(_components.code, {
        children: "undefined"
      }), " pour les supprimer du Store."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Miller\""
        }), ",\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnny\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "middleName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Lee\""
        }), " });\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ firstName: 'Johnny', middleName: 'Lee', lastName: 'Miller' })"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state"
          }), ") =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "preferredName"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Milner\""
        }), " }));\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ firstName: 'Johnny', preferredName: 'Johnny', middleName: 'Lee', lastName: 'Milner' })"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Il est possible d'utiliser des chemins en utilisant les clés des tableaux, un rayon d'objet et des fonctions de filtrage."
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "setState"
      }), " supporte aussi les options imbriquées où vous pouvez indiquer le chemin du changement. L'état que vous voulez mettre à jour peut être d'autres valeurs qui ne sont pas des objets. Les objets sont fusionnés, mais les autres valeurs (tableaux inclus) sont remplacées."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "counter"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": [\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "23"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Birds'"
        }), " }\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "27"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Fish'"
        }), " }\r\n  ]\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'counter'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'list'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "l"
          }), " =>"]
        }), " [...l, {", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "43"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Marsupials'"
        }), "}]);\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'list'"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'read'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   counter: 3,"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   list: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 23, title: 'Birds' }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 27, title: 'Fish' }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 43, title: 'Marsupials', read: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Le chemin peut être des clés en chaîne de caractère, des clés de tableau, des itérations d'objet ", jsx(_components.code, {
        children: "({ from, to, by })"
      }), " ou des fonctions de filtrage. Cela permet une expressivité impressionnante pour décrire le changement d'état."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Finish work'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Go grocery shopping'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Make dinner'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\r\n  ]\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", [", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), "], ", jsx(_components.span, {
          className: "hljs-string",
          children: "'completed'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping', completed: false }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "from"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "to"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), " }, ", jsx(_components.span, {
          className: "hljs-string",
          children: "'completed'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " !c);\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: false }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " todo.", jsx(_components.span, {
          className: "hljs-property",
          children: "completed"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'task'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "t"
          }), " =>"]
        }), " t + ", jsx(_components.span, {
          className: "hljs-string",
          children: "'!'"
        }), ")\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: false }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping!', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner!', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", {}, ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "marked"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": !todo.", jsx(_components.span, {
          className: "hljs-property",
          children: "completed"
        }), " }))\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: true, marked: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping!', completed: false, marked: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner!', completed: false, marked: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "produce",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#produce",
        children: "#"
      }), jsx(_components.code, {
        children: "produce"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " produce<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), "\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\r\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Inspiré de l'API d'Immer qui a été adapté pour les objets Store dans Solid pour permettre la mutation localisée."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "produce"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "s"
          }), ") =>"]
        }), " {\r\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "name"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Frank\""
        }), ";\r\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Pencil Crayon\""
        }), ");\r\n  })\r\n);\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "reconcile",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#reconcile",
        children: "#"
      }), jsx(_components.code, {
        children: "reconcile"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " reconcile<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "value"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\r\n  options?: {\r\n    key?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), ";\r\n    merge?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\r\n  } = { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "key"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"id\""
        }), " }\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\r\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "La comparaison de données n'est pas appliquée lorsque l'on ne peut pas appliquer de mise à jour précise. Utile quand nous voulons gérer des données immuables depuis les stores ou grosses réponses d'API."
    }), "\n", jsxs(_components.p, {
      children: ["La clé est utilisée quand les éléments associés sont disponibles. Par défaut ", jsx(_components.code, {
        children: "merge: false"
      }), " fais une vérification de référence quand c'est possible pour déterminer l'égalité et replace lorsque la référence n'est pas égale. ", jsx(_components.code, {
        children: "merge: true"
      }), " pousse toutes les comparaisons aux feuilles de l'arbre de données et remplace la donnée précédente par la nouvelle valeur de manière efficace."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// s'abonner à un observable"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " unsubscribe = store.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "{ todos }"
          }), ") =>"]
        }), " (\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "reconcile"
        }), "(todos)));\r\n);\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "unsubscribe"
        }), "());\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createmutable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createmutable",
        children: "#"
      }), jsx(_components.code, {
        children: "createMutable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMutable<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\r\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T> {\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Créer un nouvel objet Store mutable. Les stores se mettent à jour seulement quand les valeurs changent. Le traçage est fait par l'interception de l'accès de propriété et automatiquement tracé dans des imbrications profondes en utilisant un proxy."
    }), "\n", jsx(_components.p, {
      children: "Utile pour l'intégration de système externe ou en tant que couche de compatibilité avec MobX/Vue."
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: [jsx(_components.strong, {
          children: "Note:"
        }), " Un état mutable peut être passé et changer n'importe où, ce qui peut le rendre dur à suivre et peut casser le sens unidirectionnel plus facilement. Il est généralement recommandé d'utiliser ", jsx(_components.code, {
          children: "createStore"
        }), " à la place. Le modificateur ", jsx(_components.code, {
          children: "produce"
        }), " peut fournir beaucoup de ces avantages sans aucun sacrifice."]
      }), "\n"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " state = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "(initialValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// lecture de la valeur"
        }), "\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// affectation d'une valeur"
        }), "\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), " = ", jsx(_components.span, {
          className: "hljs-number",
          children: "5"
        }), ";\r\n\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(anotherValue);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Les Mutables supportent les fonctions de mutations ainsi que les fonctions accesseurs."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " user = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".firstName}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".lastName}"]
          }), "`"]
        }), ";\r\n  },\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "set"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "value"
        }), ") {\r\n    [", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "lastName"
        }), "] = value.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "split"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\" \""
        }), ");\r\n  },\r\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "apis-de-composant",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#apis-de-composant",
        children: "#"
      }), "APIs de Composant"]
    }), "\n", jsxs(_components.h2, {
      id: "createcontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcontext",
        children: "#"
      }), jsx(_components.code, {
        children: "createContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T> {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "symbol"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Provider"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["props: { value: T; children: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            }), " }"]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defaultValue"
        }), ": T;\r\n}\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createContext<T>(defaultValue?: T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ">;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Un Contexte permet une forme d'injection de dépendance dans Solid. Il est utilisé pour éviter de devoir passer des données en tant que props à travers plusieurs composants intermédiaires."
    }), "\n", jsxs(_components.p, {
      children: ["Cette fonction crée un objet contexte qui peut être utilisé grâce à ", jsx(_components.code, {
        children: "useContext"
      }), " et fournir un contrôleur de flux ", jsx(_components.code, {
        children: "Provider"
      }), ". Un contexte par défaut est utilisé quand aucun ", jsx(_components.code, {
        children: "Provider"
      }), " n'est trouvé dans la hiérarchie du haut."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CounterContext"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createContext"
        }), "([{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " }, {}]);\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "CounterProvider"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": props.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " || ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " });\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " store = [\r\n    state,\r\n    {\r\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "increment"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\r\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\r\n      },\r\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "decrement"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\r\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c - ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\r\n      },\r\n    },\r\n  ];\r\n\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\r\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "CounterContext.Provider"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "value"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{store}"
            }), ">"]
          }), "\r\n      {props.children}\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "CounterContext.Provider"
            }), ">"]
          })]
        }), "\r\n  );\r\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["La valeur donnée au ", jsx(_components.code, {
        children: "Provider"
      }), " est passée telle quelle à ", jsx(_components.code, {
        children: "useContext"
      }), ". Cela signifie qu'enrober une expression réactive ne marchera pas. Vous devrez passer des Signaux ou des Stores directement au lieu d'y accéder dans le JSX."]
    }), "\n", jsxs(_components.h2, {
      id: "usecontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usecontext",
        children: "#"
      }), jsx(_components.code, {
        children: "useContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " useContext<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "context"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T>): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Utiliser pour récupérer un contexte, et d'éviter de passer des données via les props dans chaque fonction Composant."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, { increment, decrement }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useContext"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CounterContext"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "children",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#children",
        children: "#"
      }), jsx(_components.code, {
        children: "children"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Utiliser pour faciliter l'interaction avec ", jsx(_components.code, {
        children: "props.children"
      }), ". Cette fonction d'aide résout n'importe quelle réactivité imbriquée et retourne un mémo. Cette approche est recommandée pour utiliser ", jsx(_components.code, {
        children: "props.children"
      }), " dans autre chose que l'utiliser directement dans le JSX."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " list = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// faire quelque chose avec la donnée"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "list"
        }), "());\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "lazy",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#lazy",
        children: "#"
      }), jsx(_components.code, {
        children: "lazy"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " lazy<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ">>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "default"
        }), ": T }>\r\n): T & { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "preload"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T> };\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Utiliser le chargement de composant en mode paresseux pour permettre le découpage dynamique de code. Les composants ne sont chargés qu'une fois utilisée. Les composants chargés paresseusement peuvent être utilisé de la même manière qu'un composant importé normalement, il peut recevoir des props, etc. Les composants paresseux déclenchent les ", jsx(_components.code, {
        children: "<Suspense />"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Enrobe l'import"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ComponentA"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "lazy"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "import"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./ComponentA\""
        }), "));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// utiliser dans le JSX"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ComponentA"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "title"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.title}"
            }), " />"]
          })
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "primitives-secondaires",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#primitives-secondaires",
        children: "#"
      }), "Primitives secondaires"]
    }), "\n", jsx(_components.p, {
      children: "Vous n'en aurez sûrement pas besoin pour votre première app, mais ce sont des outils utiles à avoir sous le coude."
    }), "\n", jsxs(_components.h2, {
      id: "createdeferred",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createdeferred",
        children: "#"
      }), jsx(_components.code, {
        children: "createDeferred"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createDeferred<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  options?: {\r\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\r\n    name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n    equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ");\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Créer une valeur en lecture seule qui va notifier les changements en aval quand le navigateur est inactif. ", jsx(_components.code, {
        children: "timeoutMs"
      }), " est le temps maximum attendu avant de forcer la mise à jour."]
    }), "\n", jsxs(_components.h2, {
      id: "createcomputed",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcomputed",
        children: "#"
      }), jsx(_components.code, {
        children: "createComputed"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createComputed<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\r\n  value?: T,\r\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\r\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Crée une nouvelle fonction de calcul qui va automatiquement tracer les dépendances et s'exécuter immédiatement avant le rendu. L'utiliser pour écrire sur d'autres primitives réactives. Quand c'est possible, utiliser plutôt ", jsx(_components.code, {
        children: "createMemo"
      }), " car écrire sur un signal en milieu de mise à jour peut causer d'autres fonctions à se recalculer."]
    }), "\n", jsxs(_components.h2, {
      id: "createrendereffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createrendereffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createRenderEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRenderEffect<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\r\n  value?: T,\r\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\r\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Créer un nouveau calcul qui va automatiquement tracer ces dépendances et s'exécuter durant la phase de rendu pendant que les éléments de DOM sont créés et mis à jour, mais pas nécessairement connecté. Toutes les mises à jour du DOM interne se passent à ce moment-là."
    }), "\n", jsxs(_components.h2, {
      id: "createselector",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createselector",
        children: "#"
      }), jsx(_components.code, {
        children: "createSelector"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSelector<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  fn?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "a: U, b: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ",\r\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "k: U"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Créer un signal conditionnel qui va seulement notifier les abonnées quand un élément entré ou sorti correspond à la valeur de la clé. Utile pour déléguer la sélection d'états, car l'opération devient O(1) au lieu de O(n)."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " isSelected = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSelector"
        }), "(selectedId);\r\n\r\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{list()}"
            }), ">"]
          }), "\r\n  {(item) => ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "classList"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "active:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "isSelected"
            }), "(", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), ") }}>"]
          }), "{item.name}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "}\r\n", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "rendering",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendering",
        children: "#"
      }), "Rendering"]
    }), "\n", jsxs(_components.h1, {
      id: "rendu",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendu",
        children: "#"
      }), "Rendu"]
    }), "\n", jsxs(_components.p, {
      children: ["Ces imports sont exposés depuis ", jsx(_components.code, {
        children: "solid-js/web"
      }), "."]
    }), "\n", jsxs(_components.h2, {
      id: "render",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#render",
        children: "#"
      }), jsx(_components.code, {
        children: "render"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "\r\n  code: () => JSX.Element,\r\n  element: MountableElement\r\n"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Le point d'entrée de l'application côté navigateur. Il faut fournir une définition de composant de haut niveau ou une fonction et un élément sur lequel monter l'application. Il est recommandé que cet élément soit vide, car la fonction de disposition va effacer tous les enfants."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "hydrate",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#hydrate",
        children: "#"
      }), jsx(_components.code, {
        children: "hydrate"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "\r\n  fn: () => JSX.Element,\r\n  node: MountableElement\r\n"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Cette méthode est similaire à ", jsx(_components.code, {
        children: "render"
      }), " sauf qu'elle essaye d'hydrater ce qui est déjà rendu dans le DOM. Quand elle est initialisée dans le navigateur, une page a déjà été rendue côté serveur."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostring",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostring",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToString"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToString<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  options?: {\r\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\r\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Effectue un rendu en tant que chaîne de caractères de manière synchrone. La fonction génère aussi une balise script pour l'hydratation progressive. Les options incluses ", jsx(_components.code, {
        children: "eventNames"
      }), " pour écouter des évènements avant que la page ne se charge et à l'exécution de l'hydrations et annoncer l'ajout de la balise tag."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToString"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostringasync",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostringasync",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToStringAsync"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToStringAsync<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  options?: {\r\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\r\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\r\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ">;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Similaire à ", jsx(_components.code, {
        children: "renderToString"
      }), " sauf qu'elle va attendre que toutes les limites de ", jsx(_components.code, {
        children: "<Suspense/>"
      }), " soit résolues avant de retourner le résultat. Les données des ressources sont automatiquement sérialisées dans une balise script et seront hydratées au chargement du client."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToStringAsync"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "pipetonodewritable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#pipetonodewritable",
        children: "#"
      }), jsx(_components.code, {
        children: "pipeToNodeWritable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "PipeToWritableResults"
        }), " = {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "startWriting"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "abort"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n};\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " pipeToNodeWritable<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "writable"
        }), ": { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), " },\r\n  options?: {\r\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\r\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n    noScript?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\r\n    onReady?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "r: PipeToWritableResults"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n    onComplete?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "r: PipeToWritableResults"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), " | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">;\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Cette méthode traduit en flux Node. Il traduit le contenu de manière synchrone en incluant tous les contenus de repli des Suspenses, et ensuite continus vers un flux de données provenant des ressources asynchrones au fur et à mesure de leur complétion."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipeToNodeWritable"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", res);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["L'option ", jsx(_components.code, {
        children: "onReady"
      }), " est utile pour écrire dans le flux autour du noyau du rendu de l'application. Si vous utilisez ", jsx(_components.code, {
        children: "onReady"
      }), ", vous devez appeler manuellement ", jsx(_components.code, {
        children: "startWriting"
      })]
    }), "\n", jsxs(_components.h2, {
      id: "pipetowritable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#pipetowritable",
        children: "#"
      }), jsx(_components.code, {
        children: "pipeToWritable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "PipeToWritableResults"
        }), " = {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "abort"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "script"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n};\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " pipeToWritable<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "writable"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "WritableStream"
        }), ",\r\n  options?: {\r\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\r\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n    noScript?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\r\n    onReady?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n      writable: { write: (v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            }), ") => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), " },\r\n      r: PipeToWritableResults\r\n    "]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n    onComplete?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n      writable: { write: (v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            }), ") => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), " },\r\n      r: PipeToWritableResults\r\n    "]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Cette méthode traduit en flux web. Il traduit le contenu de manière synchrone en incluant tous les contenus de repli des Suspenses, et ensuite continus vers un flux de données provenant des ressources asynchrones au fur et à mesure de leur complétion."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " { readable, writable } = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "TransformStream"
        }), "();\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipeToWritable"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", writable);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["L'option ", jsx(_components.code, {
        children: "onReady"
      }), " est utile pour écrire dans le flux autour du noyau du rendu de l'application. Si vous utilisez ", jsx(_components.code, {
        children: "onReady"
      }), ", vous devez appeler manuellement ", jsx(_components.code, {
        children: "startWriting"
      })]
    }), "\n", jsxs(_components.h2, {
      id: "isserver",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#isserver",
        children: "#"
      }), jsx(_components.code, {
        children: "isServer"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "isServer"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Cela indique si le code est exécuté côté serveur ou côté navigateur. Comme le système d'exécution exporte ceci en tant que constante booléenne, cela permet aux bundlers d'éliminer le code et leurs imports de leurs bundle respectifs."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (isServer) {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Je ne serais jamais dans le bundle du navigateur"
        }), "\r\n} ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "else"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Je ne serais jamais côté serveur"
        }), "\r\n}\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "control-flow",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#control-flow",
        children: "#"
      }), "Control Flow"]
    }), "\n", jsxs(_components.p, {
      children: ["Solid utilise les composants pour le contrôle de flux. Pour que la réactivité soit performante, nous avons besoin de contrôler comment les éléments sont créés. Par exemple, avec une liste, un simple ", jsx(_components.code, {
        children: "map"
      }), " est inefficace, car il va toujours itérer sur chaque élément. Cela veut dire qu'on doit utiliser des fonctions d'aide."]
    }), "\n", jsx(_components.p, {
      children: "Enrober ces composants est un moyen pratique pour réduire le templating et permettre aux utilisateurs de composer et construire leurs propres contrôles de flux."
    }), "\n", jsxs(_components.p, {
      children: ["Ces composants de contrôle de flux sont automatiquement importés. Tous à l'exception de ", jsx(_components.code, {
        children: "Portal"
      }), " et ", jsx(_components.code, {
        children: "Dynamic"
      }), " sont importés depuis ", jsx(_components.code, {
        children: "solid-js"
      }), ". Ces deux-là son spécifique au DOM et sont exportés par ", jsx(_components.code, {
        children: "solid-js/web"
      }), "."]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "Note : Toutes fonctions enfants au contrôle de flux sont non tracées. Cela permet d'imbriquer des créations d'états, et mieux isoler les réactions."
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "for",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#for",
        children: "#"
      }), jsx(_components.code, {
        children: "<For>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\r\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: T, index: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\r\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Simple référencement de contrôle de flux par boucle."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{item}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Le second argument optionnel est un signal index :"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item, index"
          }), ") =>"]
        }), " (\r\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\r\n      #{index()} {item}\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n  )}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "show",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#show",
        children: "#"
      }), jsx(_components.code, {
        children: "<Show>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\r\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\r\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Le contrôle de flux ", jsx(_components.code, {
        children: "Show"
      }), " est utilisée pour afficher conditionnellement une partie de la vue. Ceci est similaire à un opérateur ternaire (", jsx(_components.code, {
        children: "a ? b : c"
      }), ") mais est idéal pour le templating JSX."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " > ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "My Content", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "Show"
      }), " peut aussi être utilisé comme un moyen d'associé une clé d'un modèle de données spécifique à un bloc. Par exemple, la fonction est réexécutée quand le modèle est remplacé."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "user"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{user.firstName}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "switchmatch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#switchmatch",
        children: "#"
      }), jsx(_components.code, {
        children: "<Switch>"
      }), "/", jsx(_components.code, {
        children: "<Match>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Switch"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\r\n  fallback?: JSX.Element;\r\n  children: JSX.Element;\r\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T> = {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\r\n};\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Match"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T>);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Utile quand il y a plus de 2 conditions mutuelles exclusives. Peut-être utiliser pour faire un système de routage simple par exemple."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Not Found", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"home\""
            }), "}>"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Home"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"settings\""
            }), "}>"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Settings"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "Match"
      }), " supporte aussi une fonction enfant qui sert de flux associé à une clé."]
    }), "\n", jsxs(_components.h2, {
      id: "index",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#index",
        children: "#"
      }), jsx(_components.code, {
        children: "<Index>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\r\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: () => T, index: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\r\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Une fonction d'itération sur des listes sans clé (les lignes sont associées à un index au lieu d'une clé). Ceci est utile quand il n'y a pas de clé conceptuelle, par exemple si la donnée est composée de primitives et c'est l'index qui est fixe au lieu de la valeur."
    }), "\n", jsx(_components.p, {
      children: "L'élément est un signal :"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{item()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Le second argument optionnel est un index de type ", jsx(_components.code, {
        children: "number"
      }), " :"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item, index"
          }), ") =>"]
        }), " (\r\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\r\n      #{index} {item()}\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n  )}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "errorboundary",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#errorboundary",
        children: "#"
      }), jsx(_components.code, {
        children: "<ErrorBoundary>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ErrorBoundary"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\r\n  fallback: JSX.Element | ((err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ", reset: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          }), ") => JSX.Element);\r\n  children: JSX.Element;\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Intercepte les erreurs qui ne sont pas traitées et affiche un contenu de repli."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Something went terribly wrong", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " />"]
          })
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Il est aussi possible de passer une fonction qui va recevoir l'erreur ainsi qu'une fonction de réinitialisation."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), "\r\n  fallback={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "err, reset"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{reset}"
            }), ">"]
          }), "Error: {err.toString()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n>\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " />"]
          })
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspense",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspense",
        children: "#"
      }), jsx(_components.code, {
        children: "<Suspense>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Suspense"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\r\n  fallback?: JSX.Element;\r\n  children: JSX.Element;\r\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Un composant qui garde une trace de toutes les ressources lues dans sa portée et affiche un contenu de repli jusqu'à ce que toutes les ressources soient chargées. Ce qui rend les ", jsx(_components.code, {
        children: "Suspenses"
      }), " différents de ", jsx(_components.code, {
        children: "Show"
      }), " est l'aspect non bloquant, car les deux branches existent en même temps même si elles ne sont pas dans le DOM."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "AsyncComponent"
            }), " />"]
          })
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspenselist-expérimental",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspenselist-expérimental",
        children: "#"
      }), jsx(_components.code, {
        children: "<SuspenseList>"
      }), " (Expérimental)"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "SuspenseList"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\r\n  children: JSX.Element;\r\n  revealOrder: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"forwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"backwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"together\""
          }), ";\r\n  tail?: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"collapsed\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"hidden\""
          }), ";\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "SuspenseList"
      }), " permet de coordonner plusieurs composants ", jsx(_components.code, {
        children: "Suspense"
      }), " et ", jsx(_components.code, {
        children: "SuspenseList"
      }), " en parallèle. Il contrôle l'ordre dans la quel le contenu est révélé pour réduire les mises en page et possède une option pour fusionner ou cacher les états de repli."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), " revealOrder=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"forwards\""
        }), " tail=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"collapsed\""
        }), ">\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileDetails"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "user"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.user}"
            }), " />"]
          })
        }), "\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Loading posts...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTimeline"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "posts"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.posts}"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Loading fun facts...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTrivia"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "trivia"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.trivia}"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "SuspenseList"
      }), " est encore en phase expérimentale et ne supporte pas complètement le rendu côté serveur."]
    }), "\n", jsxs(_components.h2, {
      id: "dynamic",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#dynamic",
        children: "#"
      }), jsx(_components.code, {
        children: "<Dynamic>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), "<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T & {\r\n    children?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\r\n    component?: ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<T> | ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | keyof ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "IntrinsicElements"
        }), ";\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Ce composant vous laisse insérer un composant ou une balise arbitraire avec des props associées."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), " component={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "component"
        }), "} someProp={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "something"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "portal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#portal",
        children: "#"
      }), jsx(_components.code, {
        children: "<Portal>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Portal"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\r\n  mount?: Node;\r\n  useShadow?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\r\n  isSVG?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\r\n  children: JSX.Element;\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Text"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Ce composant va insérer un élément dans le nœud monté. C'est utile pour insérer des boîtes de dialogue en dehors de l'agencement de la page. Les évènements se propagent à travers la hiérarchie du composant."
    }), "\n", jsxs(_components.p, {
      children: ["Le portail est monté dans une ", jsx(_components.code, {
        children: "<div>"
      }), " à moins que la cible est un entête de document. ", jsx(_components.code, {
        children: "useShadow"
      }), " place l'élément dans un ", jsx(_components.code, {
        children: "ShadowRoot"
      }), " pour l'isolation de style, et ", jsx(_components.code, {
        children: "isSVG"
      }), " est requise si l'insertion est faite dans un élément SVG pour que la ", jsx(_components.code, {
        children: "<div>"
      }), " ne soit pas insérée."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), " mount={", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"modal\""
        }), ")}>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "My Content", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "attributs-jsx-spéciaux",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#attributs-jsx-spéciaux",
        children: "#"
      }), "Attributs JSX spéciaux"]
    }), "\n", jsx(_components.p, {
      children: "En général, Solid essaye de respecter un maximum les conventions du DOM. La majorité des props est traitée comme des attributs sur les éléments natifs et les propriétés dans les Web Components, mais dans quelques cas, des comportements spéciaux sont associés."
    }), "\n", jsx(_components.p, {
      children: "Pour les attributs dans un espace de noms personnalisé avec TypeScript, vous aurez besoin d'étendre l'espace de nom JSX de Solid :"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// use:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitProperties"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// prop:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitAttributes"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// attr:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomEvents"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// on:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomCaptureEvents"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// oncapture:____"
        }), "\r\n    }\r\n  }\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "ref",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#ref",
        children: "#"
      }), jsx(_components.code, {
        children: "ref"
      })]
    }), "\n", jsx(_components.p, {
      children: "Les références sont un moyen d'accéder à l'élément de DOM sous-jacent à notre JSX. Même s’il est possible d'assigner un élément dans une variable, il est plus optimal de laisser le composant dans le flux de JSX. Les références sont assignées au moment du rendu, mais avant que les éléments soient connectés au DOM. Ils peuvent avoir deux formes."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// assignation simple"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " myDiv;\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// utilisation de `onMount` ou `createEffect` pour lire après la connexion au DOM"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(myDiv));\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{myDiv}"
            }), " />"]
          })
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Ou utilisation d'une fonction (appelé avant la connexion au DOM)"
        }), "\r\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{el"
            }), " =>"]
          }), " console.log(el)} />"]
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Les références peuvent aussi être utilisées sur les Composants. Elles auront besoin d'être attachées de l'autre côté."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "MyComp"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.ref}"
            }), " />"]
          })
        }), ";\r\n}\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "App"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " myDiv;\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(myDiv.", jsx(_components.span, {
          className: "hljs-property",
          children: "clientWidth"
        }), "));\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{myDiv}"
            }), " />"]
          })
        }), ";\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "classlist",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#classlist",
        children: "#"
      }), jsx(_components.code, {
        children: "classList"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Un attribut d'aide pour utiliser ", jsx(_components.code, {
        children: "element.classList.toggle"
      }), ". Il va prendre un objet dont la clé est un nom de classes et l'assigner quand la condition sera considérée ", jsx(_components.code, {
        children: "true"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div\r\n  classList={{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "active"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "active"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "editing"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentId"
        }), " === row.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), " }}\r\n/>\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "style",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#style",
        children: "#"
      }), jsx(_components.code, {
        children: "style"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["L'attribut style fonctionne soit comme avec une chaîne de caractère soit avec un objet. À la différence de React, Solid utilise ", jsx(_components.code, {
        children: "element.style.setProperty"
      }), " en coulisse. Cela signifie que les variables CSS sont supportées, mais aussi que nous devons utiliser la version dash-case des propriétés. Cela donne de meilleures performances et une meilleure cohésion avec le résultat du rendu côté serveur."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// chaine de caractère"
        }), "\r\n<div style={", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`color: green; background-color: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.color}"
          }), "; height: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.height}"
          }), "px`"]
        }), "} />\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// objet"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), "\r\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "color:"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "green"
            }), "\",\r\n  \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "background-color"
            }), "\"", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.color"
            }), ",\r\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "height:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.height"
            }), " + \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "px"
            }), "\" }}\r\n/>"]
          })
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// variable css"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "--my-custom-color"
            }), "\"", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.themeColor"
            }), " }} />"]
          })
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "innerhtmltextcontent",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#innerhtmltextcontent",
        children: "#"
      }), jsx(_components.code, {
        children: "innerHTML"
      }), "/", jsx(_components.code, {
        children: "textContent"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Ils fonctionnent de la même manière que la propriété. Passez une chaîne de caractère et elle sera affichée. ", jsx(_components.strong, {
        children: "Attention !!!"
      }), " Utiliser ", jsx(_components.code, {
        children: "innerHTML"
      }), " avec n'importe quelle donnée peut exposer vos utilisateurs à des risques, car cela peut être exploité comme faille de sécurité. ", jsx(_components.code, {
        children: "textContent"
      }), " bien que généralement pas utiliser peut être une optimisation de performance quand vous savez que l'enfant ne sera que du texte, car il évite la comparaison générique."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div textContent={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "text"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "on___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___",
        children: "#"
      }), jsx(_components.code, {
        children: "on___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Les gestionnaires d'évènement dans Solid prennent typiquement la forme de ", jsx(_components.code, {
        children: "onclick"
      }), " ou ", jsx(_components.code, {
        children: "onClick"
      }), " en fonction du style du code. Le nom de l'évènement est en minuscule. Solid utilise une délégation d'évènement semi-synthétique pour les évènements communs à l'interface utilisateur qui ne sont pas composés et remontés. Cela améliore les performances pour les évènements communs."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div onClick={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentTarget"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Solid supporte aussi de fournir un tableau au gestionnaire d'évènement pour associer la valeur au premier argument de la fonction de gestion d'évènement. Cela n'utilise pas ", jsx(_components.code, {
        children: "bind"
      }), " ou créer de fonction additionnelle, donc c'est un moyen très optimisé de déléguer des évènements."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "handler"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "itemId, e"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*...*/"
        }), "\r\n}\r\n\r\n<ul>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.list}"
            }), ">"]
          }), "{(item) => ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{[handler,"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), "]} />"]
          }), "}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), "\r\n</ul>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Les évènements ne peuvent pas rebondir et l'association n'est pas réactive, car c'est généralement plus coûteux d'attacher/détacher des écouteurs. Vu que les évènements sont naturellement appelés, il n'y a pas besoin de réactivité."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// si défini, l'appeler, sinon ne rien faire."
        }), "\r\n<div onClick={", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "handleClick"
        }), "?.()} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "on___oncapture___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___oncapture___",
        children: "#"
      }), jsx(_components.code, {
        children: "on:___"
      }), "/", jsx(_components.code, {
        children: "oncapture:___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Pour tous les autres évènements, comme un évènement avec un nom non conventionnel ou un que vous souhaitez ne pas déléguer, il existe ", jsx(_components.code, {
        children: "on"
      }), " qui va simplement ajouter un écouteur d'évènement."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "on"
        }), ":", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Weird"
        }), "-", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Event"
        }), "={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "alert"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "detail"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "use___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#use___",
        children: "#"
      }), jsx(_components.code, {
        children: "use:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "Il existe des directives personnalisées. C'est en quelque sorte du sucre syntaxique autour des références pour permettre de facilement attacher plusieurs directives à un même élément. Une directive est simplement une fonction avec la signature suivante :"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "directive"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["element: Element, accessor: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Les fonctions directives sont appelées au moment du rendu, mais avant d'être ajouté au DOM. Vous pouvez faire ce que vous souhaitez à l'intérieur, y compris créer des signaux, effets, programmer des fonctions de nettoyage, etc."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [name, setName] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "el, value"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [field, setField] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "value"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRenderEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " (el.", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "field"
        }), "()));\r\n  el.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"input\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setField"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "target"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), "));\r\n}\r\n\r\n<input type=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"text\""
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "use"
        }), ":model={[name, setName]} />;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Pour étendre l'espace de noms de JSX dans TypeScript."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-attr",
          children: "model"
        }), ": [", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "];\r\n    }\r\n  }\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "prop___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#prop___",
        children: "#"
      }), jsx(_components.code, {
        children: "prop:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "Force la prop à être traitée comme une propriété au lieu d'un attribut."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "prop"
        }), ":scrollTop={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "scrollPos"
        }), " + ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"px\""
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "attr___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#attr___",
        children: "#"
      }), jsx(_components.code, {
        children: "attr:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "Force la prop à être traitée comme un attribut au lieu d'une propriété. C'est utile pour les Web Components où vous voulez associer un attribut."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<my-element ", jsx(_components.span, {
          className: "hljs-attr",
          children: "attr"
        }), ":status={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "status"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "-once-",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#-once-",
        children: "#"
      }), jsx(_components.code, {
        children: "/* @once */"
      })]
    }), "\n", jsx(_components.p, {
      children: "Le compilateur de Solid utilise une façon heuristique pour enrober la réactivité et évaluer paresseusement une expression JSX. Est-ce qu'il contient un appel à une fonction, accède à une propriété ou au JSX ? Si oui, nous l'enrobons dans un accesseur quand il est passé à un composant ou un effet s’il est passé à un élément natif."
    }), "\n", jsxs(_components.p, {
      children: ["En sachant ça, nous pouvons réduire la pénalisation effective pour les choses qui ne vont pas changer en y accédant depuis l'extérieur de JSX. Une simple variable ne sera jamais enrobée. Nous pouvons aussi dire au compilateur de ne pas les enrober en commençant une expression avec un commentaire décoratif ", jsx(_components.code, {
        children: "/_ @once _/"
      }), "."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "static"
        }), "={", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " state.", jsx(_components.span, {
          className: "hljs-property",
          children: "wontUpdate"
        }), "} />\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Cela fonctionne aussi sur les enfants."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), ">{", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " state.", jsx(_components.span, {
          className: "hljs-property",
          children: "wontUpdate"
        }), "}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), ">\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=api-269b29e0.js.map
