import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [{
  "depth": 1,
  "value": "Basic Reactivity",
  "children": [{
    "depth": 2,
    "value": "createSignal",
    "children": [{
      "depth": 5,
      "value": "Options",
      "children": []
    }]
  }, {
    "depth": 2,
    "value": "createEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createMemo",
    "children": []
  }, {
    "depth": 2,
    "value": "createResource",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Lifecycles",
  "children": [{
    "depth": 2,
    "value": "onMount",
    "children": []
  }, {
    "depth": 2,
    "value": "onCleanup",
    "children": []
  }, {
    "depth": 2,
    "value": "onError",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Reactive Utilities",
  "children": [{
    "depth": 2,
    "value": "untrack",
    "children": []
  }, {
    "depth": 2,
    "value": "batch",
    "children": []
  }, {
    "depth": 2,
    "value": "on",
    "children": []
  }, {
    "depth": 2,
    "value": "createRoot",
    "children": []
  }, {
    "depth": 2,
    "value": "getOwner",
    "children": []
  }, {
    "depth": 2,
    "value": "runWithOwner",
    "children": []
  }, {
    "depth": 2,
    "value": "mergeProps",
    "children": []
  }, {
    "depth": 2,
    "value": "splitProps",
    "children": []
  }, {
    "depth": 2,
    "value": "useTransition",
    "children": []
  }, {
    "depth": 2,
    "value": "startTransition",
    "children": []
  }, {
    "depth": 2,
    "value": "observable",
    "children": []
  }, {
    "depth": 2,
    "value": "from",
    "children": []
  }, {
    "depth": 2,
    "value": "mapArray",
    "children": []
  }, {
    "depth": 2,
    "value": "indexArray",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Stores",
  "children": [{
    "depth": 2,
    "value": "스토어 사용하기",
    "children": [{
      "depth": 3,
      "value": "createStore",
      "children": [{
        "depth": 4,
        "value": "스토어에서의 배열",
        "children": []
      }]
    }, {
      "depth": 3,
      "value": "Getters",
      "children": []
    }, {
      "depth": 3,
      "value": "스토어 업데이트",
      "children": []
    }]
  }, {
    "depth": 2,
    "value": "스토어 유틸리티",
    "children": [{
      "depth": 3,
      "value": "produce",
      "children": []
    }, {
      "depth": 3,
      "value": "reconcile",
      "children": []
    }, {
      "depth": 3,
      "value": "unwrap",
      "children": []
    }, {
      "depth": 3,
      "value": "createMutable",
      "children": []
    }, {
      "depth": 3,
      "value": "modifyMutable",
      "children": []
    }]
  }]
}, {
  "depth": 1,
  "value": "Component APIs",
  "children": [{
    "depth": 2,
    "value": "createContext",
    "children": []
  }, {
    "depth": 2,
    "value": "useContext",
    "children": []
  }, {
    "depth": 2,
    "value": "children",
    "children": []
  }, {
    "depth": 2,
    "value": "lazy",
    "children": []
  }, {
    "depth": 2,
    "value": "createUniqueId",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Secondary Primitives",
  "children": [{
    "depth": 2,
    "value": "createDeferred",
    "children": []
  }, {
    "depth": 2,
    "value": "createRenderEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createComputed",
    "children": []
  }, {
    "depth": 2,
    "value": "createReaction",
    "children": []
  }, {
    "depth": 2,
    "value": "createSelector",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Rendering",
  "children": [{
    "depth": 2,
    "value": "render",
    "children": []
  }, {
    "depth": 2,
    "value": "hydrate",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToString",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToStringAsync",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToStream",
    "children": []
  }, {
    "depth": 2,
    "value": "isServer",
    "children": []
  }, {
    "depth": 2,
    "value": "HydrationScript",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Control Flow",
  "children": [{
    "depth": 2,
    "value": "<For>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Show>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Switch>/<Match>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Index>",
    "children": []
  }, {
    "depth": 2,
    "value": "<ErrorBoundary>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Suspense>",
    "children": []
  }, {
    "depth": 2,
    "value": "<SuspenseList> (실험 단계)",
    "children": []
  }, {
    "depth": 2,
    "value": "<Dynamic>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Portal>",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "특별한 JSX 속성",
  "children": [{
    "depth": 2,
    "value": "ref",
    "children": []
  }, {
    "depth": 2,
    "value": "classList",
    "children": []
  }, {
    "depth": 2,
    "value": "style",
    "children": []
  }, {
    "depth": 2,
    "value": "innerHTML/textContent",
    "children": []
  }, {
    "depth": 2,
    "value": "on___",
    "children": []
  }, {
    "depth": 2,
    "value": "on:___/oncapture:___",
    "children": []
  }, {
    "depth": 2,
    "value": "use:___",
    "children": []
  }, {
    "depth": 2,
    "value": "prop:___",
    "children": []
  }, {
    "depth": 2,
    "value": "attr:___",
    "children": []
  }, {
    "depth": 2,
    "value": "/* @once */",
    "children": []
  }]
}];
function _createMdxContent(props) {
  const _components = Object.assign({
    h1: "h1",
    a: "a",
    p: "p",
    em: "em",
    code: "code",
    h2: "h2",
    pre: "pre",
    span: "span",
    blockquote: "blockquote",
    h5: "h5",
    strong: "strong",
    ul: "ul",
    li: "li",
    h3: "h3",
    h4: "h4"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.h1, {
      id: "basic-reactivity",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#basic-reactivity",
        children: "#"
      }), "Basic Reactivity"]
    }), "\n", jsxs(_components.p, {
      children: ["반응성에 대한 Solid의 전반적인 접근 방식은 모든 리액티브 계산을 함수로 래핑하고 디펜던시가 업데이트될 때 해당 함수를 다시 실행하는 것입니다.\r\nSolid JSX 컴파일러는 또는 대부분의 JSX 표현식 (중괄호 안의 코드)을 함수로 래핑하므로, 디펜던시가 변경되면 자동으로 업데이트(및 해당 DOM 업데이트)합니다.\r\n보다 정확하게는, 함수의 자동 재실행은 ", jsx(_components.em, {
        children: "추적 범위"
      }), " 내에서 함수가 호출될 때마다 발생합니다. 추적 범위는 JSX 표현식이나 \"계산\"(", jsx(_components.code, {
        children: "createEffect"
      }), ", ", jsx(_components.code, {
        children: "createMemo"
      }), ", 등)을 빌드하는 API 호출을 의미합니다.\r\n기본적으로 함수의 디펜던시는 추적 범위에서 호출될 때 함수가 리액티브 상태를 읽는 것(예: 시그널 getter 혹은 Store 속성을 통해)을 감지하여 자동으로 추적됩니다.\r\n결과적으로, 보통은 디펜던시에 대해 걱정할 필요가 없습니다(하지만 자동 디펜던시 추적이 원하는 결과를 생성하지 않는 경우, ", jsx(_components.a, {
        href: "#reactive-utilities",
        children: "디펜던시 추적을 오버라이드"
      }), " 할 수 있습니다.)\r\n이 접근 방식은 반응성을 ", jsx(_components.em, {
        children: "구성 가능"
      }), " 하게 만듭니다: 다른 함수에서 하나의 함수를 호출하면 일반적으로 호출하는 함수가 호출되는 함수의 디펜던시를 상속합니다."]
    }), "\n", jsxs(_components.h2, {
      id: "createsignal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createsignal",
        children: "#"
      }), jsx(_components.code, {
        children: "createSignal"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createSignal } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSignal<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "initialValue"
        }), ": T,\r\n  options?: { equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\r\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T];\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// createSignal 반환값에 사용 가능한 타입:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Signal"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Accessor"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Setter"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Signal"
        }), "<T> = [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Accessor"
        }), "<T>, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Setter"
        }), "<T>];\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Accessor"
        }), "<T> = ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Setter"
        }), "<T> = ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T | ((prev?: T) => T)"
          }), ") =>"]
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["시그널은 가장 기본적인 리액티브 프리미티브입니다. 이는 시간에 따라 변하는 단일 값(자바스크립트 객체)을 추적합니다.\r\n시그널의 초기값은 전달된 첫 번째 인자인 ", jsx(_components.code, {
        children: "initialValue"
      }), " (미지정시 ", jsx(_components.code, {
        children: "undefined"
      }), ") 값으로 시작합니다.\r\n", jsx(_components.code, {
        children: "createSignal"
      }), " 함수는 ", jsx(_components.em, {
        children: "getter"
      }), " (또는 ", jsx(_components.em, {
        children: "accessor"
      }), ")와 ", jsx(_components.em, {
        children: "setter"
      }), " 함수 2개를 가진 배열을 반환합니다. 보통은 다음과 같이 디스트럭처링을 사용해 배열을 이름을 가진 시그널에 할당합니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [count, setCount] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [ready, setReady] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["getter (예: ", jsx(_components.code, {
        children: "count()"
      }), " 혹은 ", jsx(_components.code, {
        children: "ready()"
      }), ")를 호출하면 시그널의 현재 값을 반환합니다.\r\n자동 디펜던시 추적에 있어 중요한 부분은, 추적 범위 내에서 getter를 호출하게 되면 호출하는 함수는 해당 시그널에 의존하게 되므로, 시그널이 업데이트되면 해당 함수가 다시 실행됩니다."]
    }), "\n", jsxs(_components.p, {
      children: ["setter(예: ", jsx(_components.code, {
        children: "setCount(nextCount)"
      }), " 혹은 ", jsx(_components.code, {
        children: "setReady(nextReady)"
      }), ")를 호출하면 시그널의 값을 설정하고, 값이 실제로 변경된 경우 (자세한 내용은 아래쪽 참고) 시그널을 ", jsx(_components.em, {
        children: "업데이트"
      }), "(디펜던시가 있는 항목을 다시 실행하도록 트리거링)합니다 ."]
    }), "\n", jsx(_components.p, {
      children: "setter의 유일한 인수로 시그널의 새 값이나 시그널의 마지막 값을 새 값에 매핑하는 함수를 사용합니다.\r\nsetter는 업데이트된 값도 반환합니다. 예를 들어:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 시그널의 현재 값"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 추적 범위 내에 있는 경우 시그널에 디펜던시를 가집니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// (추적 범위 밖에서는 리액티브하지 않음):"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " currentCount = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 또는 계산식을 함수로 래핑"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이 함수는 추적 범위 내에서 사용될 수 있습니다:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "doubledCount"
        }), " = (", jsx(_components.span, {
          className: "hljs-params"
        }), ") => ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), " * ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 또는 추적 범위를 생성하고, 시그널에 의존성을 가집니다:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " countDisplay = ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{count()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 시그널 setter에 값 설정:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setReady"
        }), "(", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 시그널 setter에 함수 사용:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " newCount = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " prev + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "시그널에 함수를 저장하고 싶다면 함수 형식를 사용해야 합니다:"
      }), "\n", jsx(_components.pre, {
        children: jsxs(_components.code, {
          className: "hljs language-js",
          children: [jsx(_components.span, {
            className: "hljs-title function_",
            children: "setValue"
          }), "(", jsx(_components.span, {
            className: "hljs-function",
            children: "() =>"
          }), " myFunction);\n"]
        })
      }), "\n", jsxs(_components.p, {
        children: ["함수를 ", jsx(_components.code, {
          children: "createSignal"
        }), "의 ", jsx(_components.code, {
          children: "initialValue"
        }), " 인수로 사용시에는 그대로 전달해야 합니다:"]
      }), "\n", jsx(_components.pre, {
        children: jsxs(_components.code, {
          className: "hljs language-js",
          children: [jsx(_components.span, {
            className: "hljs-keyword",
            children: "const"
          }), " [func, setFunc] = ", jsx(_components.span, {
            className: "hljs-title function_",
            children: "createSignal"
          }), "(myFunction);\n"]
        })
      }), "\n"]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.a, {
        href: "#batch",
        children: "batch"
      }), ", ", jsx(_components.a, {
        href: "#createeffect",
        children: "effect"
      }), ", ", jsx(_components.a, {
        href: "#usetransition",
        children: "transition"
      }), "에 있는 것이 아니라면, 시그널은 설정하는 즉시 업데이트됩니다.\r\n예를 들어:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "setReady"
        }), "(", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assert"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ready"
        }), "() === ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setReady"
        }), "(", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assert"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ready"
        }), "() === ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "코드가 batch 혹은 transition(예: 라이브러리 코드)으로 실행될지 확실하지 않다면, 이러한 가정은 피해야 합니다."
    }), "\n", jsxs(_components.h5, {
      id: "options",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#options",
        children: "#"
      }), "Options"]
    }), "\n", jsxs(_components.p, {
      children: ["Solid의 여러 프리미티브들은 \"options\" 객체를 마지막 옵셔널 인수로 받습니다.\r\n", jsx(_components.code, {
        children: "createSignal"
      }), "의 옵션 객체에는 ", jsx(_components.code, {
        children: "equals"
      }), " 옵션이 있습니다. 예를 들어:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [getValue, setValue] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(initialValue, { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "equals"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " });\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["기본적으로 시그널의 setter를 호출할 때, 자바스크립트의 ", jsx(_components.code, {
        children: "==="
      }), " 연산자에 따라 새 값이 이전 값과 다른 경우에만 시그널이 업데이트되고 디펜던시 항목들이 재실행됩니다.\r\n", jsx(_components.code, {
        children: "equals"
      }), "를 ", jsx(_components.code, {
        children: "false"
      }), "로 설정하면 setter가 호출된 후 디펜던시 항목들을 항상 다시 실행하거나, 동등성 테스트를 위한 커스텀 함수를 제공할 수 있습니다.\r\n몇 가지 예를 살펴보면:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 객체의 내용을 변경하는 것을 허용하려면 { equals: false } 을 사용합니다;"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 일반적으로는 변경 전후에 동일한 객체를 가리키고 있기 때문에, 업데이트로 보지 않습니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [object, setObject] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " }, { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "equals"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " });\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setObject"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "current"
          }), ") =>"]
        }), " {\r\n  current.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " += ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ";\r\n  current.", jsx(_components.span, {
          className: "hljs-property",
          children: "updated"
        }), " = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Date"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " current;\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// { equals: false } 시그널의 값을 지정하지 않는 경우 트리거로 사용할 수 있습니다:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [depend, rerun] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ", { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "equals"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " });\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 추적 범위에서 depend() 를 호출하면 rerun() 이 호출될 때마다 해당 범위가 다시 실행됩니다."
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 문자열의 길이에 따라 동등성 비교 정의:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [myString, setMyString] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"string\""
        }), ", {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "equals"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "oldVal, newVal"
          }), ") =>"]
        }), " newVal.", jsx(_components.span, {
          className: "hljs-property",
          children: "length"
        }), " === oldVal.", jsx(_components.span, {
          className: "hljs-property",
          children: "length"
        }), ",\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setMyString"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"strung\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이전 값과 동일한 것으로 판단해 업데이트가 발생하지 않습니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setMyString"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"stranger\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이전 값과 다른 것으로 판단해 업데이트가 발생합니다."
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createeffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createeffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createEffect } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createEffect<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T, value?: T): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["이펙트는 디펜던시가 변경될 때마다 임의의 코드(\"사이드 이펙트\": 예를 들면, DOM을 수동으로 변경하는 것과 같은)를 실행하도록 하는 일반적인 방법입니다. ", jsx(_components.code, {
        children: "createEffect"
      }), "는 추적 범위에서 주어진 함수를 실행하는 새 계산을 생성하여 디펜던시를 자동으로 추적하고, 디펜던시가 업데이트될 때마다 함수를 자동으로 다시 실행합니다.\r\n예를 들면:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [a, setA] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(initialValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 시그널 `a`에 디펜던시를 가지는 이펙트"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "doSideEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "()));\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["이펙트 함수는 이펙트 함수의 마지막 실행에서 반환된 값과 동일한 인수로 호출됩니다.\r\n첫 호출시에는 ", jsx(_components.code, {
        children: "createEffect"
      }), " 호출시 사용한 2번째 인수를 사용해 호출됩니다.\r\n이렇게 하면 마지막으로 계산된 값을 기억하기 위해 추가 클로저를 만들지 않고도 diff를 계산할 수 있습니다.\r\n예를 들어:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " sum = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "() + ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (sum !== prev) ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"sum changed to\""
        }), ", sum);\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " sum;\r\n}, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["이펙트는 주로 리액티브 시스템에 쓰기를 하지 않고 읽기만 하는 사이드 이펙트에 대한 것입니다:\r\n이펙트 안에서는 시그널을 설정하지 않는것이 가장 좋습니다. 부주의하게 사용하는 경우 추가 렌더링이나 무한 이펙트 루프를 유발할 수 있습니다.\r\n대신 ", jsx(_components.a, {
        href: "#creatememo",
        children: jsx(_components.code, {
          children: "createMemo"
        })
      }), "를 사용하여 다른 리액티브 값에 의존하는 새 값을 계산하는 편이 좋습니다. 이렇게 하면 리액티브 시스템은 의존 관계를 파악할 수 있으므로 그에 따라 최적화할 수 있습니다."]
    }), "\n", jsxs(_components.p, {
      children: ["이펙트 안에서 시그널을 설정하면, 이펙트 함수는 자동으로 ", jsx(_components.a, {
        href: "#batch",
        children: jsx(_components.code, {
          children: "batch"
        })
      }), "로 래핑되며, 이는 이펙트 내부의 모든 시그널 변경 사항은 이펙트가 완료된 후에만 전파됨을 의미합니다.\r\n이렇게 되면 여러 시그널 업데이트는 하나의 업데이트만 트리거하면서, 사이드 이펙트 중간에 원치 않는 사이드 이펙트가 발생하는 것을 방지할 수 있습니다.\r\n실제로 여러 이펙트가 한꺼번에 트리거되면, 이들은 모두 묶어 하나의 ", jsx(_components.code, {
        children: "batch"
      }), "로 래핑됩니다."]
    }), "\n", jsxs(_components.p, {
      children: ["이펙트 함수의 ", jsx(_components.em, {
        children: "첫 번째"
      }), " 실행은 바로 실행되지 않으며, 현재 렌더링 단계 이후에 실행되도록 예약됩니다(예: ", jsx(_components.a, {
        href: "#render",
        children: jsx(_components.code, {
          children: "render"
        })
      }), ", ", jsx(_components.a, {
        href: "#createroot",
        children: jsx(_components.code, {
          children: "createRoot"
        })
      }), ", ", jsx(_components.a, {
        href: "#runwithowner",
        children: jsx(_components.code, {
          children: "runWithOwner"
        })
      }), " 에 전달된 함수를 호출한 후).\r\n첫 번째 실행시까지 대기하려면, 브라우저가 DOM을 렌더링하기 전에 실행되는 ", jsx(_components.a, {
        href: "https://developer.mozilla.org/en-US/docs/Web/API/queueMicrotask",
        children: jsx(_components.code, {
          children: "queueMicrotask"
        })
      }), " 를 사용하거나, 브라우저 렌더링 후에 실행되는 ", jsx(_components.code, {
        children: "await Promise.resolve()"
      }), " 혹은 ", jsx(_components.code, {
        children: "setTimeout(..., 0)"
      }), " 을 사용하세요.\r\n첫 번째 실행 후, 이펙트는 일반적으로 디펜던시가 업데이트될 때 즉시 실행됩니다(", jsx(_components.a, {
        href: "#batch",
        children: "batch"
      }), " 혹은 ", jsx(_components.a, {
        href: "#usetransition",
        children: "transition"
      }), "인 경우는 예외입니다).\r\n예를 들어:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이 코드는 컴포넌트 함수 안에 있다고 가정하며, 따라서 렌더링 단계의 일부입니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [count, setCount] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이 이펙트는 처음 실행시와 변경시 count를 출력합니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count =\""
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "()));\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이펙트 아직 미실행"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"hello\""
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이펙트 아직 미실행"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ");  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이펙트 아직 미실행"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "queueMicrotask"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이제 `count = 2` 출력"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"microtask\""
        }), ");\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "3"
        }), ");  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 바로 `count = 3` 출력"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"goodbye\""
        }), ");\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// --- 전체 출력: ---"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// hello"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// count = 2"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// microtask"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// count = 3"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// goodbye"
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["첫 번째 실행 지연은 컴포넌트에서 반환된 JSX가 DOM에 추가된 후에 컴포넌트 스코프에 정의된 이펙트가 실행된다는 의미이므로 유용합니다.\r\n특히, ", jsx(_components.a, {
        href: "#ref",
        children: jsx(_components.code, {
          children: "ref"
        })
      }), " 는 이미 설정된 상태가 됩니다.\r\n따라서 이펙트를 사용해 DOM을 수동으로 조작하거나, 바닐라 JS 라이브러리를 호출하거나, 다른 사이드 이펙트를 일으킬 수 있습니다."]
    }), "\n", jsxs(_components.p, {
      children: ["이펙트의 첫 번째 실행은 브라우저가 DOM을 렌더링하기 전에 실행됩니다(리액트의 ", jsx(_components.code, {
        children: "useLayoutEffect"
      }), "와 유사합니다).\r\n렌더링 후까지 대기해야 하는 경우 (예: 렌더링 시간 측정), ", jsx(_components.code, {
        children: "await Promise.resolve()"
      }), " (혹은 ", jsx(_components.code, {
        children: "Promise.resolve().then(...)"
      }), ")를 사용할 수 있지만, 시그널 같은 리액티브 상태를 사용하게 되면 재실행을 위한 이펙트가 트리거되지 않게 됩니다. 이는 ", jsx(_components.code, {
        children: "async"
      }), " 함수가 ", jsx(_components.code, {
        children: "await"
      }), "를 사용한 후에는 추적이 불가능하기 때문입니다.\r\n따라서 promise 전에 모든 디펜던시를 사용해야 합니다."]
    }), "\n", jsxs(_components.p, {
      children: ["이펙트를 처음 실행할 때도 즉시 실행하려면, ", jsx(_components.a, {
        href: "#createrendereffect",
        children: jsx(_components.code, {
          children: "createRenderEffect"
        })
      }), " 또는 ", jsx(_components.a, {
        href: "#createcomputed",
        children: jsx(_components.code, {
          children: "createComputed"
        })
      }), " 를 사용하세요."]
    }), "\n", jsxs(_components.p, {
      children: ["이펙트 함수 _안_에서 ", jsx(_components.a, {
        href: "#oncleanup",
        children: jsx(_components.code, {
          children: "onCleanup"
        })
      }), "을 호출해 이펙트 함수 실행 사이의 사이드 이펙트를 정리할 수 있습니다.\r\n이런 클린업 함수는 이펙트 실행 사이와 이펙트가 삭제(예: 포함하는 컴포넌트가 언마운트)될 때 모두 호출됩니다.\r\n예를 들어:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// eventName 시그널에서 발생하는 이벤트 리스닝"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " event = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "eventName"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "callback"
        }), " = (", jsx(_components.span, {
          className: "hljs-params",
          children: "e"
        }), ") => ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(e);\r\n  ref.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(event, callback);\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ref.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "removeEventListener"
        }), "(event, callback));\r\n});\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "creatememo",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#creatememo",
        children: "#"
      }), jsx(_components.code, {
        children: "createMemo"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createMemo } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMemo<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\r\n  value?: T,\r\n  options?: { equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["메모를 사용하면 파생된 값을 많은 리액티브 계산에서 효율적으로 재사용할 수 있습니다.\r\n", jsx(_components.code, {
        children: "createMemo"
      }), "는 주어진 함수의 반환 값과 동일한 읽기 전용 리액티브 값을 생성하고, 디펜던시가 변경될 때만 함수가 실행되도록 합니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " value = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "computeExpensiveValue"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "(), ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 값 읽기"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "value"
        }), "();\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Solid에서는 함수를 메모로 래핑할 필요가 없는 경우가 종종 있습니다; 대신 유사한 리액티브 동작을 얻기 위해 일반 함수를 정의하고 호출할 수 있습니다.\r\n주요 차이점은 여러 리액티브 설정들에서 함수를 호출하는 경우입니다.\r\n함수의 디펜던시가 업데이트될 때, ", jsx(_components.code, {
        children: "createMemo"
      }), "로 래핑되어 있지 않으면 한 함수가 여러 번 호출됩니다.\r\n예를 들어:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " user = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "searchForUser"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "username"
        }), "()));\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 다음 함수와 비교: const user = () => searchForUser(username());"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ul"
            }), ">"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "Your name is \"{user()?.name}\"", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "\r\n      Your email is ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "code"
            }), ">"]
          }), "{user()?.email}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "code"
            }), ">"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "ul"
            }), ">"]
          })]
        }), "\r\n);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "username"
      }), " 시그널이 업데이트되면, ", jsx(_components.code, {
        children: "searchForUser"
      }), "가 한 번만 호출됩니다.\r\n반환된 ", jsx(_components.code, {
        children: "user"
      }), "가 실제로 변경되면 ", jsx(_components.code, {
        children: "user"
      }), " 메모가 업데이트되고, 두 리스트 항목이 자동으로  업데이트됩니다.\r\n만일 ", jsx(_components.code, {
        children: "user"
      }), " 정의를 ", jsx(_components.code, {
        children: "() => searchForUser(username())"
      }), " 일반 함수로 교체하면, ", jsx(_components.code, {
        children: "searchForUser"
      }), "는 두 번(각 리스트 아이템 업데이트시마다) 호출됩니다."]
    }), "\n", jsxs(_components.p, {
      children: ["또 다른 주요 차이점은 메모의 디펜던시가 변경되었지만 메모의 값이 변경되지 않은 경우, 의존 항목이 업데이트되지 않도록 보호할 수 있다는 점입니다.\r\n", jsx(_components.a, {
        href: "#createsignal",
        children: jsx(_components.code, {
          children: "createSignal"
        })
      }), "과 마찬가지로, ", jsx(_components.code, {
        children: "createMemo"
      }), "에 의해 생성된 파생 시그널은 메모 함수에서 반환된 값이 ", jsx(_components.code, {
        children: "==="
      }), " 연산자에 따라 이전값에서 변경된 경우만 _업데이트_하고, 의존 항목들을 다시 실행하도록 트리거합니다.\r\n또는  ", jsx(_components.code, {
        children: "equals"
      }), "가 ", jsx(_components.code, {
        children: "false"
      }), "로 설정된 옵션 객체를 전달해 디펜던시가 변경되면 메모를 항상 업데이트하거나, 동등성 비교를 위한 커스텀 ", jsx(_components.code, {
        children: "equals"
      }), " 함수를 전달할 수 있습니다."]
    }), "\n", jsxs(_components.p, {
      children: ["메모 함수는 메모 함수의 마지막 실행에서 반환된 값과 동일한 인수로 호출되며, 첫 번째 호출시에는 ", jsx(_components.code, {
        children: "createMemo"
      }), " 실행시 전달한 두 번째 옵셔널 인수를 사용해 호출됩니다.\r\n이는 계산을 줄이는데 유용합니다. 예를 들면:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// input()이 취한 모든 값의 합을 추적합니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " sum = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "input"
        }), "() + prev, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "메모 함수는 setter를 호출해 다른 시그널을 변경해서는 안되며, \"순수\" 함수여야 합니다.\r\n이를 통해 Solid는 디펜던시 그래프에 따라 메모 업데이트 순서를 최적화할 수 있으므로, 디펜던시 변경에 대한 응답으로 모든 메모가 한꺼번에 업데이트될 수 있습니다."
    }), "\n", jsxs(_components.h2, {
      id: "createresource",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createresource",
        children: "#"
      }), jsx(_components.code, {
        children: "createResource"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createResource } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T> = [\r\n  {\r\n    (): T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "loading"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "error"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "latest"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\r\n  },\r\n  {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mutate"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "refetch"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["info: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "unknown"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T> | T;\r\n  }\r\n];\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ">(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n    k: U,\r\n    info: { value: T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            }), "; refetching: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "boolean"
            }), " | ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "unknown"
            }), " }\r\n  "]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\r\n  options?: { initialValue?: T }\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), "),\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n    k: U,\r\n    info: { value: T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            }), "; refetching: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "boolean"
            }), " | ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "unknown"
            }), " }\r\n  "]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\r\n  options?: { initialValue?: T }\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "비동기 요청의 결과를 반영하는 시그널을 생성합니다."
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createResource"
      }), "는 비동기 fetcher 함수를 실행하고, fetcher 실행이 끝나면 결과 데이터로 업데이트되는 시그널을 반환합니다.\r\n", jsx(_components.code, {
        children: "createResource"
      }), "를 사용하는 2가지 방법이 있습니다: fetcher 함수만 인수로 전달하거나, 소스 시그널을 첫 번째 인수로 추가로 전달할 수 있습니다.\r\n소스 시그널은 변경될 때마다 fetcher를 다시 트리거하고 그 값은 fetcher에 전달됩니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [data, { mutate, refetch }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(fetchData);\n"]
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [data, { mutate, refetch }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(sourceSignal, fetchData);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["이 스니펫에서 ", jsx(_components.code, {
        children: "fetchData"
      }), "가 fetcher 함수이며, ", jsx(_components.code, {
        children: "fetchData"
      }), "가 실행을 끝낼때까지 ", jsx(_components.code, {
        children: "data()"
      }), "는 정의되지 않습니다.\r\n첫 번째 경우, ", jsx(_components.code, {
        children: "fetchData"
      }), "는 즉시 실행됩니다.\r\n두 번째 경우, ", jsx(_components.code, {
        children: "sourceSignal"
      }), "이 ", jsx(_components.code, {
        children: "false"
      }), ", ", jsx(_components.code, {
        children: "null"
      }), ", ", jsx(_components.code, {
        children: "undefined"
      }), " 이외의 값을 갖는 즉시 ", jsx(_components.code, {
        children: "fetchData"
      }), "가 호출됩니다.\r\n", jsx(_components.code, {
        children: "sourceSignal"
      }), " 값이 변경될 때마다 다시 호출되며, 그 값은 항상 ", jsx(_components.code, {
        children: "fetchData"
      }), " 함수의 첫 번째 인수로 전달됩니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "mutate"
      }), "를 호출해 ", jsx(_components.code, {
        children: "data"
      }), " 시그널을 직접 업데이트(다른 시그널 setter 처럼 동작)할 수 있습니다.\r\n", jsx(_components.code, {
        children: "refetch"
      }), "를 호출해 fetcher를 직접 다시 실행하고, ", jsx(_components.code, {
        children: "refetch(info)"
      }), "와 같이 옵셔널 인수를 전달하여 fetcher에 추가 정보를 제공할 수 있습니다: ."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "data"
      }), "는 일반 시그널 getter처럼 작동합니다: ", jsx(_components.code, {
        children: "data()"
      }), "를 사용해 ", jsx(_components.code, {
        children: "fetchData"
      }), "의 마지막 반환 값을 읽습니다.\r\n하지만 두 가지 추가 리액티브 속성이 있습니다: ", jsx(_components.code, {
        children: "data.loading"
      }), "은 fetcher가 호출되었지만 아직 반환되지 않았는지를 알려주며, ", jsx(_components.code, {
        children: "data.error"
      }), "는 요청에 에러가 발생했는지 알려줍니다; 에러에는 fetcher에서 발생한 오류도 포합됩니다. (참고: 에러가 예상된다면, ", jsx(_components.a, {
        href: "#errorboundary",
        children: "ErrorBoundary"
      }), "에 ", jsx(_components.code, {
        children: "createResource"
      }), "를 래핑할 수 있습니다.)"]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.strong, {
        children: "1.4.0"
      }), " 버전에서는, ", jsx(_components.code, {
        children: "data.latest"
      }), "는 마지막으로 반환된 값을 반환하며, ", jsx(_components.a, {
        href: "#suspense",
        children: "Suspense"
      }), "와 ", jsx(_components.a, {
        href: "#usetransition",
        children: "트랜지션"
      }), "을 트리거하지 않습니다; 아직 값이 반환된 적이 없다면, ", jsx(_components.code, {
        children: "data.latest"
      }), "는 ", jsx(_components.code, {
        children: "data()"
      }), "와 동일하게 작동합니다. 이는 새 데이터를 로딩하는 도중에는 이전 데이터를 보여주고자 하는 경우 유용합니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "loading"
      }), ", ", jsx(_components.code, {
        children: "error"
      }), ", ", jsx(_components.code, {
        children: "latest"
      }), "는 리액티브 getter이며 추적 가능합니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "fetcher"
      }), "는 데이터를 가져오기 위해 ", jsx(_components.code, {
        children: "createResource"
      }), "에 제공하는 비동기 함수입니다.\r\nfetcher에는 두 개의 인수가 전달됩니다. 소스 시그널의 값(제공된 경우), 그리고 ", jsx(_components.code, {
        children: "value"
      }), ", ", jsx(_components.code, {
        children: "refetching"
      }), " 속성을 가진 정보 객체입니다. ", jsx(_components.code, {
        children: "value"
      }), "는 이전에 가져온 값을 알려줍니다.\r\nfetcher가 ", jsx(_components.code, {
        children: "refetch"
      }), " 함수를 사용해 트리거된 경우 ", jsx(_components.code, {
        children: "refetching"
      }), " 값이 ", jsx(_components.code, {
        children: "true"
      }), "가 되며, 그 외의 경우 ", jsx(_components.code, {
        children: "false"
      }), "가 됩니다.\r\n", jsx(_components.code, {
        children: "refetch"
      }), " 함수가 ", jsx(_components.code, {
        children: "refetch(info)"
      }), "처럼 인수와 함께 호출된 경우, ", jsx(_components.code, {
        children: "refetching"
      }), "이 해당 인수로 설정됩니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "async"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fetchData"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "source, { value, refetching }"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 데이터를 가져와 값을 반환합니다."
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "//`source`: 소스 시그널의 현재 값을 알려줍니다;"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "//`value`: fetcher의 마지막 반환값을 알려줍니다;"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "//`refetching`: fetcher가 `refetch()`를 호출해 트리거될 때, 또는 `refetch(info)` 처럼 전달된 옵셔널 인수와 동일한 경우 true"
        }), "\r\n\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [data, { mutate, refetch }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(getQuery, fetchData);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 값 읽기"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "data"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 로딩중인지 확인"
        }), "\r\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "loading"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 에러 발생 여부 확인"
        }), "\r\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "error"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// promise를 생성하지 않고 직접 값 설정"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mutate"
        }), "(optimisticValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 마지막 요청을 명시적으로 다시 가져옵니다"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "refetch"
        }), "();\n"]
      })
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "v1.4.0 에서 추가됨"
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "renderToStream"
      }), "을 사용중이라면, ", jsx(_components.code, {
        children: "deferStream"
      }), " 옵션을 사용해 리소스가 준비될 때까지 Solid가 스트림 플러시를 하지 않고 기다리도록 할 수 있습니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// user 데이터를 가져오는 것과 컨텐츠 스트리밍을 최대한 빨리 진행합니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [user] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " params.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), ", fetchUser);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// user 데이터를 가져와 리소스가 로드된 후, 컨텐츠 스트리밍을 진핸합니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [user] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " params.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), ", fetchUser, {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "deferStream"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ",\r\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "lifecycles",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#lifecycles",
        children: "#"
      }), "Lifecycles"]
    }), "\n", jsxs(_components.h2, {
      id: "onmount",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onmount",
        children: "#"
      }), jsx(_components.code, {
        children: "onMount"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { onMount } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["초기 렌더링 및 엘리먼트가 마운트된 후 실행되는 메서드를 등록합니다.\r\n", jsx(_components.code, {
        children: "ref"
      }), "를 사용하고 다른 일회성 사이드 이펙트를 관리하는 데 이상적입니다.\r\n디펜던시가 없는 ", jsx(_components.code, {
        children: "createEffect"
      }), "와 동일합니다."]
    }), "\n", jsxs(_components.h2, {
      id: "oncleanup",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#oncleanup",
        children: "#"
      }), jsx(_components.code, {
        children: "onCleanup"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { onCleanup } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "현재 리액티브 스코프를 폐기하거나 재계산시 실행되는 클린업 메서드를 등록합니다.\r\n모든 컴포넌트와 이펙트에서 사용 가능합니다."
    }), "\n", jsxs(_components.h2, {
      id: "onerror",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onerror",
        children: "#"
      }), jsx(_components.code, {
        children: "onError"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { onError } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onError"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: (err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ") => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "자식 스코프에서 에러가 발생한 경우 실행되는 에러 핸들러 메서드를 등록합니다.\r\n가장 가까운 스코프에 있는 에러 핸들러만 실행되며, 상위로 전달하려면 에러를 다시 던지면 됩니다."
    }), "\n", jsxs(_components.h1, {
      id: "reactive-utilities",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#reactive-utilities",
        children: "#"
      }), "Reactive Utilities"]
    }), "\n", jsx(_components.p, {
      children: "이 헬퍼 함수들은 보다 나은 업데이트 스케줄 및 반응성 추적을 제어하는 기능을 제공합니다."
    }), "\n", jsxs(_components.h2, {
      id: "untrack",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#untrack",
        children: "#"
      }), jsx(_components.code, {
        children: "untrack"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { untrack } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " untrack<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "실행 코드 블럭의 디펜던시 추적을 무시하고 값을 반환합니다."
    }), "\n", jsxs(_components.h2, {
      id: "batch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#batch",
        children: "#"
      }), jsx(_components.code, {
        children: "batch"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { batch } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " batch<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["불필요한 재계산을 막기 위해, 블럭 내에서의 업데이트 커밋을 마지막까지 미룹니다.\r\n이는 다음 행에서 읽는 값이 아직 업데이트되지 않았음을 의미합니다.\r\n", jsx(_components.a, {
        href: "#createstore",
        children: "Solid 스토어"
      }), "의 set 메서드, ", jsx(_components.a, {
        href: "#createmutable",
        children: "Mutable 스토어"
      }), "의 array 메서드, 이펙트는 자동으로 해당 코드를 일괄 처리합니다."]
    }), "\n", jsxs(_components.h2, {
      id: "on",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on",
        children: "#"
      }), jsx(_components.code, {
        children: "on"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { on } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " on<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "> | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "), U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "deps"
        }), ": T,\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "input: T, prevInput: T, prevValue?: U"
          }), ") =>"]
        }), " U,\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "options"
        }), ": { defer?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), " } = {}\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prevValue?: U"
          }), ") =>"]
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "on"
      }), "은 디펜던시가 명시적으로 계산에 전달되로록 디자인되었습니다.\r\n디펜던시 배열이 전달되는 경우, ", jsx(_components.code, {
        children: "input"
      }), "과 ", jsx(_components.code, {
        children: "prevInput"
      }), "도 배열입니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "())));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 위 코드는 다음 코드와 동일합니다:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " v = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "untrack"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\r\n});\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "defer 옵션을 true로 설정해 계산을 바로 실행하지 않고 변경시에만 실행되도록 선택할 수 있습니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 바로 실행하지 않습니다"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v), { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defer"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), " }));\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setA"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"new\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 여기서 실행됩니다."
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "stores"
      }), "와 ", jsx(_components.code, {
        children: "mutable"
      }), "에서 부모 객체에서 속성을 추가하거나 삭제하면 이펙트가 트리거됩니다.\r\n", jsx(_components.a, {
        href: "#createmutable",
        children: jsx(_components.code, {
          children: "createMutable"
        })
      }), " 참조."]
    }), "\n", jsxs(_components.h2, {
      id: "createroot",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createroot",
        children: "#"
      }), jsx(_components.code, {
        children: "createRoot"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createRoot } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRoot<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["dispose: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "자동으로 삭제되지 않고 추적되지 않은 새 스코프를 생성합니다.\r\n부모가 재평가할 때, 해제하고 싶지 않은 중첩된 리액티브 스코프가 있는 경우 유용하게 사용할 수 있습니다."
    }), "\n", jsxs(_components.p, {
      children: ["모든 Solid 코드는 모든 메모리와 계산이 해제되도록 보장하기 때문에, 이런 최상위 레벨 중 하나로 래핑되어야 합니다.\r\n일반적으로 ", jsx(_components.code, {
        children: "createRoot"
      }), "는 모든 ", jsx(_components.code, {
        children: "render"
      }), " 엔트리 함수에 포함되어 있기 때문에 이에 대해 걱정할 필요는 없습니다."]
    }), "\n", jsxs(_components.h2, {
      id: "getowner",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#getowner",
        children: "#"
      }), jsx(_components.code, {
        children: "getOwner"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { getOwner } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getOwner"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), "): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Owner"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["현재 실행중인 코드를 소유하는 리액티브 스코프를 반환합니다. 예를 들면, 나중에 현재 스코프 외부에서 ", jsx(_components.code, {
        children: "runWithOwner"
      }), " 호출시 전달하기 위해 사용합니다."]
    }), "\n", jsxs(_components.p, {
      children: ["내부적으로, 계산(이펙트, 메모, 등)은 ", jsx(_components.code, {
        children: "createRoot"
      }), "나 ", jsx(_components.code, {
        children: "render"
      }), "에 의해 생성된 루트 소유자까지 따라 올라가면서 자식 소유자를 생성합니다.\r\nSolid는 이러한 소유권 트리를 통해 서브 트리를 탐색하고 모든 ", jsx(_components.a, {
        href: "#oncleanup",
        children: jsx(_components.code, {
          children: "onCleanup"
        })
      }), " 콜백을 호출함으로써 삭제된 계산을 자동으로 정리할 수 있습니다.\r\n예를 들어, ", jsx(_components.code, {
        children: "createEffect"
      }), "의 디펜던시가 변경되면, 이펙트는 이펙트 함수를 다시 실행하기 전에 모든 하위 ", jsx(_components.code, {
        children: "onCleanup"
      }), " 콜백을 호출합니다.\r\n", jsx(_components.code, {
        children: "getOwner"
      }), "를 호출하면 현재 실행 블럭의 폐기를 담당하는 현재 소유자 노드가 반환됩니다."]
    }), "\n", jsxs(_components.p, {
      children: ["컴포넌트는 계산이 아니므로 소유자 노드를 생성하지 않지만, 일반적으로 ", jsx(_components.code, {
        children: "createEffect"
      }), "에서 렌더링되므로 결과는 비슷합니다: 컴포넌트가 언마운트되면 모든 하위 ", jsx(_components.code, {
        children: "onCleanup"
      }), " 콜백이 호출됩니다.\r\n컴포넌트 스코프에서 ", jsx(_components.code, {
        children: "getOwner"
      }), "를 호출하면 컴포넌트 렌더링과 언마운트를 담당하는 소유자가 반환됩니다."]
    }), "\n", jsxs(_components.p, {
      children: ["리액티브 스코프를 소유한다고 해서 반드시 _추적_하는 것은 아닙니다.\r\n예를 들어, ", jsx(_components.a, {
        href: "#untrack",
        children: jsx(_components.code, {
          children: "untrack"
        })
      }), "은 JSX (", jsx(_components.code, {
        children: "<Component ...>"
      }), ")를 통해 생성된 컴포넌트와 마찬가지로 함수 실행시 새로운 리액티브 스코프를 생성하지 않고 추적을 끕니다."]
    }), "\n", jsxs(_components.h2, {
      id: "runwithowner",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#runwithowner",
        children: "#"
      }), jsx(_components.code, {
        children: "runWithOwner"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { runWithOwner } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " runWithOwner<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "owner"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Owner"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["() => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " T): T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["외부 스코프의 소유자 대신, 제공된 소유자 아래에서 주어진 함수를 실행합니다.\r\n기본적으로 ", jsx(_components.code, {
        children: "createEffect"
      }), ", ", jsx(_components.code, {
        children: "createMemo"
      }), " 등에 의해 생성된 계산은 현재 실행중인 코드의 소유자(", jsx(_components.code, {
        children: "getOwner"
      }), "의 반환값)가 소유하므로, 소유자가 삭제될 때 같이 삭제됩니다.\r\n", jsx(_components.code, {
        children: "runWithOwner"
      }), "를 호출하면 기본값을 지정한 소유자(일반적으로 ", jsx(_components.code, {
        children: "getOwner"
      }), "에 대한 이전 호출의 반환값)로 오버라이드할 수 있으므로, 계산이 삭제되는 시점을 보다 정확하게 제어할 수 있습니다."]
    }), "\n", jsx(_components.p, {
      children: "(올바른) 소유자를 갖는 것은 다음과 같은 두 가지 이유때문에 중요합니다:"
    }), "\n", jsxs(_components.ul, {
      children: ["\n", jsxs(_components.li, {
        children: ["소유자가 없는 계산은 삭제할 수 없습니다. 예를 들어, 소유자 없이 ", jsx(_components.code, {
          children: "createEffect"
        }), "를 호출하게 되면(예: 전역 스코프), 이펙트는 소유자가 삭제될 때 같이 삭제되는 대신 영원히 실행됩니다."]
      }), "\n", jsxs(_components.li, {
        children: [jsx(_components.a, {
          href: "#usecontext",
          children: jsx(_components.code, {
            children: "useContext"
          })
        }), "는 소유자 트리를 찾아 올라가면서 원하는 컨텍스트를 제공하는 가장 가까운 조상을 찾아 컨텍스트를 얻습니다. 따라서 소유자가 없으면 제공된 컨텍스트를 찾을 수 없으며, 잘못된 소유자가 있다면 잘못된 컨텍스트를 얻을 수 있습니다."]
      }), "\n"]
    }), "\n", jsxs(_components.p, {
      children: ["소유자를 수동으로 설정하면, 소유자의 스코프 외부에서 반응성을 수행할 때 유용합니다.\r\n특히 ", jsx(_components.code, {
        children: "async"
      }), " 함수나 ", jsx(_components.code, {
        children: "setTimeout"
      }), " 같은 콜백을 통한 비동기 계산은 자동으로 설정된 소유자를 잃기 때문에, ", jsx(_components.code, {
        children: "getOwner"
      }), "를 통해 원래 소유자를 기억하고 ", jsx(_components.code, {
        children: "runWithOwner"
      }), "를 통해 복원하는 작업이 필요합니다.\r\n예를 들어:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " owner = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getOwner"
        }), "();\r\n", jsx(_components.span, {
          className: "hljs-built_in",
          children: "setTimeout"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이 콜백은 소유자없이 실행됩니다."
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// runWithOwner를 통해 소유자를 복원합니다:"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "runWithOwner"
        }), "(owner, ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " foo = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useContext"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "FooContext"
        }), ");\r\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(foo);\r\n    });\r\n  });\r\n}, ", jsx(_components.span, {
          className: "hljs-number",
          children: "1000"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["디펜던시 추적을 결정하는 것은 소유자가 아니므로, ", jsx(_components.code, {
        children: "runWithOwner"
      }), "는 비동기 함수에서 추적하는데 도움이 되지 않습니다; 비동기 파트(예: 첫 번째 ", jsx(_components.code, {
        children: "await"
      }), " 이후)에서 리액티브 상태를 사용하더라도 디펜던시로 추적되지 않습니다."]
    }), "\n", jsxs(_components.h2, {
      id: "mergeprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#mergeprops",
        children: "#"
      }), jsx(_components.code, {
        children: "mergeProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { mergeProps } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["...sources: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "리액티브 객체를 머지하는 메서드입니다.\r\n호출자가 설정하지 않은 props의 디폴트 값을 설정하거나, 리액티브 속성을 포함해 props 객체를 복제할 때 유용합니다."
    }), "\n", jsx(_components.p, {
      children: "이 메서드는 프록시를 사용하며 속성을 역순으로 확인하는 식으로 작동하기 때문에, prop 객체가 처음 머지되었을때 존재하지 않은 속성의 동적 추적을 가능하게 합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 디폴트 props"
        }), "\r\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "name"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), " }, props);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// props 복제"
        }), "\r\nnewProps = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(props);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// props 머지"
        }), "\r\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(props, otherProps);\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "splitprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#splitprops",
        children: "#"
      }), jsx(_components.code, {
        children: "splitProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { splitProps } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " splitProps<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T,\r\n  ...", jsx(_components.span, {
          className: "hljs-attr",
          children: "keys"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<(keyof T)[]>\r\n): [...", jsx(_components.span, {
          className: "hljs-attr",
          children: "parts"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Partial"
        }), "<T>];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "리액티브 객체를 키를 사용해 분할합니다."
    }), "\n", jsx(_components.p, {
      children: "리액티브 객체와, 키의 배열들을 인수로 받습니다; 원래 객체에서 키 배열에 있는 속성들만 포함하는 리액티브 객체를 반환합니다.\r\n반환되는 배열의 마지막 리액티브 객체에는 원래 객체의 나머지 속성들이 포함됩니다."
    }), "\n", jsx(_components.p, {
      children: "props의 일부 속성만 사용하고 나머지는 자식에게 전달하려는 경유 유용합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), " a={", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), "} b={", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), "} c={", jsx(_components.span, {
          className: "hljs-number",
          children: "3"
        }), "} d={", jsx(_components.span, {
          className: "hljs-number",
          children: "4"
        }), "} e={", jsx(_components.span, {
          className: "hljs-number",
          children: "5"
        }), "} foo=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"bar\""
        }), " />;\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "MyComponent"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(props); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {a: 1, b: 2, c: 3, d: 4, e: 5, foo: \"bar\"}"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [vowels, consonants, leftovers] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "splitProps"
        }), "(\r\n    props,\r\n    [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"a\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"e\""
        }), "],\r\n    [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"b\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"c\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"d\""
        }), "]\r\n  );\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(vowels); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {a: 1, e: 5}"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(consonants); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {b: 2, c: 3, d: 4}"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(leftovers.", jsx(_components.span, {
          className: "hljs-property",
          children: "foo"
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// bar"
        }), "\r\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "splitProps"
      }), "는 임의의 갯수의 배열을 인수로 받기 때문에 원하는만큼 props 객체를 분할할 수 있습니다. props의 서브셋이 필요한 여러 자식 컴포넌트가 있는 경우를 예로 들 수 있습니다."]
    }), "\n", jsx(_components.p, {
      children: "컴포넌트에 6개의 props가 전달되었다고 가정해 보겠습니다:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), " a={", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), "} b={", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), "} c={", jsx(_components.span, {
          className: "hljs-number",
          children: "3"
        }), "} d={", jsx(_components.span, {
          className: "hljs-number",
          children: "4"
        }), "} e={", jsx(_components.span, {
          className: "hljs-number",
          children: "5"
        }), "} foo=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"bar\""
        }), "/>\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "MyComponent"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(props) ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {a: 1, b: 2, c: 3, d: 4, e: 5, foo: \"bar\"}"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [vowels, consonants, leftovers] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "splitProps"
        }), "(props,\r\n          [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"a\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"e\""
        }), "], [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"b\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"c\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"d\""
        }), "]);\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(vowels) ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {a: 1, e: 5}"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(consonants) ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {b: 2, c: 3, d: 4}"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(leftovers.", jsx(_components.span, {
          className: "hljs-property",
          children: "foo"
        }), ") ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// bar"
        }), "\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "usetransition",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usetransition",
        children: "#"
      }), jsx(_components.code, {
        children: "useTransition"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { useTransition } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), "): [\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "pending"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "startTransition"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["fn: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">\r\n];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "모든 비동기 프로세스가 완료될 때까지 커밋을 연기하는 트랜잭션에서 비동기 업데이트를 일괄 처리하는데 사용됩니다.\r\n이는 Suspense와 연결되어 있으며, Suspense 경계에서 읽은 리소스만 추적합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [isPending, start] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 트랜지션중인지 확인"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "isPending"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 트랜지션 래핑"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "start"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setSignal"
        }), "(newValue), ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/* 트랜지션 완료 */"
        }), ")\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "starttransition",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#starttransition",
        children: "#"
      }), jsx(_components.code, {
        children: "startTransition"
      })]
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "v1.1.0 에 추가된 기능"
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { startTransition } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "startTransition"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["fn: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "useTransition"
      }), "과 유사하지만, 연결된 pending 상태가 없다는 점이 다릅니다. 트랜지션을 시작하기 위해 직접 사용할 수 있습니다."]
    }), "\n", jsxs(_components.h2, {
      id: "observable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#observable",
        children: "#"
      }), jsx(_components.code, {
        children: "observable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { observable } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " observable<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "input"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Observable"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["이 메서드는 시그널을 받아 Observable을 생성합니다.\r\n일반적으로 ", jsx(_components.code, {
        children: "from"
      }), " 오퍼레이터를 사용해 선택한 다른 Observable 라이브러리에서 사용할 수 있습니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// solid.js 시그널과 rxjs 연동"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { observable } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"rxjs\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [s, set] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " obsv$ = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "from"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "observable"
        }), "(s));\r\n\r\nobsv$.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v));\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "rxjs"
      }), "없이 ", jsx(_components.code, {
        children: "from"
      }), "을 사용할 수도 있습니다; 아래 참조."]
    }), "\n", jsxs(_components.h2, {
      id: "from",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#from",
        children: "#"
      }), jsx(_components.code, {
        children: "from"
      })]
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "v1.1.0 에 추가된 기능"
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), "<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "producer"
        }), ":\r\n    | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "setter: (v: T) => T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ")\r\n    | {\r\n        ", jsx(_components.span, {
          className: "hljs-attr",
          children: "subscribe"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n          fn: (v: T) => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), "\r\n        "]
          }), ") =>"]
        }), " (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ") | { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "unsubscribe"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), " };\r\n      }\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["RxJS Observable 또는 Svelte Store와 같은 외부 생산자와 더 쉽게 연동할 수 있도록 하는 헬퍼 함수입니다.\r\n이는 기본적으로 모든 구독 가능한 것(", jsx(_components.code, {
        children: "subscribe"
      }), " 메서드가 있는 객체)을 시그널로 바꾸고, 구독과 폐기를 관리합니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " signal = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "from"
        }), "(obsv$);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "또한 setter 함수를 인수로 받아서 구독 취소 함수를 반환하는 커스텀 생산자 함수를 사용할 수 있습니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " clock = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "from"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "set"
          }), ") =>"]
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " t = ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "setInterval"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "set"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), "), ", jsx(_components.span, {
          className: "hljs-number",
          children: "1000"
        }), ");\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "clearInterval"
        }), "(t);\r\n});\n"]
      })
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: ["참고: ", jsx(_components.code, {
          children: "from"
        }), "에 의해 생성된 시그널은 외부 스트림 및 소스와의 더 나은 인트페이스를 위해 동등성 체크가 꺼져 있습니다."]
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "maparray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#maparray",
        children: "#"
      }), jsx(_components.code, {
        children: "mapArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { mapArray } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " mapArray<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T, i: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "업데이트시 불필요한 매핑을 줄이기 위해, 참조로 각 항목을 캐시하는 리액티브 map 헬퍼 함수입니다.\r\n값당 한 번만 매핑 함수를 실행하며, 이 후에는 필요에 따라 이동하거나 삭제합니다.\r\n인덱스 인수는 시그널입니다.\r\nmap 함수 자체는 추적하지 않습니다."
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<For>"
      }), " 제어 흐름 내부에서 사용하고 있습니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mapArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "model"
          }), ") =>"]
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [name, setName] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(model.", jsx(_components.span, {
          className: "hljs-property",
          children: "name"
        }), ");\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [description, setDescription] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(model.", jsx(_components.span, {
          className: "hljs-property",
          children: "description"
        }), ");\r\n\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": model.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "name"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "name"
        }), "();\r\n    },\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "description"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "description"
        }), "();\r\n    },\r\n    setName,\r\n    setDescription,\r\n  };\r\n});\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "indexarray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#indexarray",
        children: "#"
      }), jsx(_components.code, {
        children: "indexArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { indexArray } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " indexArray<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: () => T, i: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["인덱스로 매핑한다는 점을 제외하면 ", jsx(_components.code, {
        children: "mapArray"
      }), "와 유사합니다.\r\n각 항목은 시그널이며, 인덱스는 상수입니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<Index>"
      }), " 제어 흐름 내부에서 사용하고 있습니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "indexArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "model"
          }), ") =>"]
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "id"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "firstInitial"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), "[", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "];\r\n    },\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${model().firstName}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${model().lastName}"
          }), "`"]
        }), ";\r\n    },\r\n  }\r\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "stores",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#stores",
        children: "#"
      }), "Stores"]
    }), "\n", jsxs(_components.p, {
      children: ["이 API들은 ", jsx(_components.code, {
        children: "solid-js/store"
      }), "에 포함되어 있습니다.\r\n이 API들을 사용하면 스토어를 생성할 수 있습니다.\r\n스토어는 시그널 트리를 독립적으로 추적하고 수정할 수 있도록 하는 ", jsx(_components.a, {
        href: "https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Proxy",
        children: "프록시 객체"
      }), "입니다."]
    }), "\n", jsxs(_components.h2, {
      id: "스토어-사용하기",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#스토어-사용하기",
        children: "#"
      }), "스토어 사용하기"]
    }), "\n", jsxs(_components.h3, {
      id: "createstore",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createstore",
        children: "#"
      }), jsx(_components.code, {
        children: "createStore"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createStore } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SetStoreFunction"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createStore<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>\r\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SetStoreFunction"
        }), "<T>];\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T> = T;  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 개념상 읽기 전용이지만, 타입은 그렇게 설정되지 않음"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "create 함수는 초기 상태를 가져와 저장소에 래핑하고, 읽기 전용 프록시 객체와 setter 함수를 반환합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "(initialValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 값 읽기"
        }), "\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 값 설정"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "merge"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"thisValue\""
        }), " });\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"path\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"to\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"value\""
        }), ", newValue);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "프록시로서 스토어 객체는 속성에 액세스할 때만 추적합니다."
    }), "\n", jsxs(_components.p, {
      children: ["중첩된 객체에 액세스할 때 스토어는 중첩된 스토어 객체를 생성하며, 이는 트리 아래 끝까지 적용됩니다.\r\n하지만 이는 배열과 일반 객체에만 적용됩니다.\r\n클래스는 래핑되지 않기 때문에, ", jsx(_components.code, {
        children: "Date"
      }), ", ", jsx(_components.code, {
        children: "HTMLElement"
      }), ", ", jsx(_components.code, {
        children: "RegExp"
      }), ", ", jsx(_components.code, {
        children: "Map"
      }), ", ", jsx(_components.code, {
        children: "Set"
      }), " 과 같은 객체는 스토어의 속성으로 세분화된 반응성을 제공하지 않습니다."]
    }), "\n", jsxs(_components.h4, {
      id: "스토어에서의-배열",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#스토어에서의-배열",
        children: "#"
      }), "스토어에서의 배열"]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.strong, {
        children: "1.4.0"
      }), " 버전에서는, 최상위 상태 객체는 배열이 될 수 있습니다. 이전 버전에서는 배열을 감싸는 객체를 사용해야 합니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Solid 1.4.0 이상"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [todos, setTodos] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "([\r\n  { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Thing I have to do\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "done"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " },\r\n  { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Learn a New Framework\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "done"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " },\r\n]);\r\n...\r\n<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={todos}>{", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Todo"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "todo"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{todo}"
            }), " />"]
          })
        }), "}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">;\n"]
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 1.4.0 미만"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Thing I have to do\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "done"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " },\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Learn a New Framework\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "done"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " },\r\n  ],\r\n});\r\n<For each={state.todos}>{(todo) => <Todo todo={todo} />}<For>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "스토어 안에 있는 배열을 변경하는 경우, 배열을 직접 구독하는 계산은 트리거되지 않습니다. 예를 들어:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(state.", jsx(_components.span, {
          className: "hljs-property",
          children: "todos"
        }), ");\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이펙트를 트리거하지 않습니다:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(todos, state.", jsx(_components.span, {
          className: "hljs-property",
          children: "todos"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "length"
        }), ", { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "3"
        }), " });\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 배열의 레퍼런스가 변경되었기 때문에, 이펙트를 트리거합니다:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"todos\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " [...prev, { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "3"
        }), " }]);\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "getters",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#getters",
        children: "#"
      }), "Getters"]
    }), "\n", jsx(_components.p, {
      children: "스토어 객체는 getter가 계산된 값을 사용하는 것을 지원합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".firstName}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".lastName}"]
          }), "`"]
        }), ";\r\n    },\r\n  },\r\n});\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "getter는 액세스할 때마다 실행되기 때문에, 값을 캐시하려면 여전히 메모를 사용해야 합니다:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " fullName;\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "();\r\n    },\r\n  },\r\n});\r\nfullName = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.user.firstName}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.user.lastName}"
          }), "`"]
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "스토어-업데이트",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#스토어-업데이트",
        children: "#"
      }), "스토어 업데이트"]
    }), "\n", jsxs(_components.p, {
      children: ["변경 함수는 이전 상태를 받아서 새 상태나 값을 반환하는 함수의 형태를 취할 수 있습니다.\r\n객체는 항상 얕게 머지됩니다.\r\n스토어에서 값을 삭제하려면 값을 ", jsx(_components.code, {
        children: "undefined"
      }), "로 설정하세요."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Miller\""
        }), ",\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnny\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "middleName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Lee\""
        }), " });\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ firstName: 'Johnny', middleName: 'Lee', lastName: 'Miller' })"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state"
          }), ") =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "preferredName"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Milner\""
        }), " }));\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ firstName: 'Johnny', preferredName: 'Johnny', middleName: 'Lee', lastName: 'Milner' })"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "키 배열, 객체 범위, 필터 함수를 포함하는 경로를 지원합니다."
    }), "\n", jsx(_components.p, {
      children: "setState는 변경할 경로를 나타낼 수 있는 중첩된 설정도 지원합니다.\r\n중첩된 상태에서는 업데이트하는 상태가 Object 값이 아닐 수도 있습니다.\r\nObject는 머지되지만, 다른 값(배열 포함)은 대체됩니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "counter"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": [\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "23"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Birds'"
        }), " }\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "27"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Fish'"
        }), " }\r\n  ]\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'counter'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'list'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "l"
          }), " =>"]
        }), " [...l, {", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "43"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Marsupials'"
        }), "}]);\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'list'"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'read'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   counter: 3,"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   list: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 23, title: 'Birds' }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 27, title: 'Fish' }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 43, title: 'Marsupials', read: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "경로는 문자열 키, 키 배열, 반복 객체({from, to, by}), 필터 함수일 수 있으며, 이는 상태 변화를 표시하기 위한 놀라운 표현력을 제공합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Finish work'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Go grocery shopping'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Make dinner'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\r\n  ]\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", [", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), "], ", jsx(_components.span, {
          className: "hljs-string",
          children: "'completed'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping', completed: false }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "from"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "to"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), " }, ", jsx(_components.span, {
          className: "hljs-string",
          children: "'completed'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " !c);\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: false }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " todo.", jsx(_components.span, {
          className: "hljs-property",
          children: "completed"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'task'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "t"
          }), " =>"]
        }), " t + ", jsx(_components.span, {
          className: "hljs-string",
          children: "'!'"
        }), ")\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: false }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping!', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner!', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", {}, ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "marked"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": !todo.", jsx(_components.span, {
          className: "hljs-property",
          children: "completed"
        }), " }))\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: true, marked: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping!', completed: false, marked: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner!', completed: false, marked: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "스토어-유틸리티",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#스토어-유틸리티",
        children: "#"
      }), "스토어 유틸리티"]
    }), "\n", jsxs(_components.h3, {
      id: "produce",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#produce",
        children: "#"
      }), jsx(_components.code, {
        children: "produce"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { produce } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " produce<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), "\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\r\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Immer에서 영감을 받은 API로, Solid 스토어 객체에 대한 로컬라이즈된 변경을 허용합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "produce"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "s"
          }), ") =>"]
        }), " {\r\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "name"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Frank\""
        }), ";\r\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Pencil Crayon\""
        }), ");\r\n  })\r\n);\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "reconcile",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#reconcile",
        children: "#"
      }), jsx(_components.code, {
        children: "reconcile"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { reconcile } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " reconcile<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "value"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\r\n  options?: {\r\n    key?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), ";\r\n    merge?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\r\n  } = { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "key"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"id\""
        }), " }\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\r\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "세분화된 업데이트를 적용할 수 없는 경우 데이터 변경 사항에 대한 diff를 수행합니다.\r\n스토어나 대규모 API 응답의 불변 데이터를 처리할 때 유용합니다."
    }), "\n", jsxs(_components.p, {
      children: ["key는 항목을 일치시킬 수 있을 때 사용됩니다.\r\n기본적으로 ", jsx(_components.code, {
        children: "merge"
      }), "는 ", jsx(_components.code, {
        children: "false"
      }), " 이며, 가능하면 참조 검사를 수행해 동등성을 판단하고 항목이 동일한 참조가 아닌 경우 이를 대체합니다.\r\n", jsx(_components.code, {
        children: "merge"
      }), "가 ", jsx(_components.code, {
        children: "true"
      }), "이면, 모든 diff를 사용해 이전 데이터를 새 값으로 효과적으로 머지합니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// observable 구독"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " unsubscribe = store.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "{ todos }"
          }), ") =>"]
        }), " (\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "reconcile"
        }), "(todos)));\r\n);\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "unsubscribe"
        }), "());\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "unwrap",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#unwrap",
        children: "#"
      }), jsx(_components.code, {
        children: "unwrap"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { unwrap } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "unwrap"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "store: Store<T>"
        }), "): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "프록시 없이 스토어 내부 데이터를 반환합니다."
    }), "\n", jsxs(_components.h3, {
      id: "createmutable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createmutable",
        children: "#"
      }), jsx(_components.code, {
        children: "createMutable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createMutable } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMutable<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "새로운 변경 가능한 스토어 프록시 객체를 생성합니다.\r\n스토어는 값이 변경될 때만 업데이트를 트리거합니다.\r\n추적은 속성 액세스를 가로채서 수행되며, 프록시를 통해 깊은 중첩을 자동으로 추적합니다."
    }), "\n", jsx(_components.p, {
      children: "외부 시스템을 통합하거나, MobX/Vue 와의 호환성 레이어로 유용합니다."
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: [jsx(_components.strong, {
          children: "참고:"
        }), " 변경 가능한 상태는 어디에나 전달되고 변경될 수 있으므로, 단방향 흐름을 따라가기 어렵고, 이를 쉽게 깰 수 있게 됩니다.\r\n일반적으로 ", jsx(_components.code, {
          children: "createStore"
        }), "를 대신 사용하는 것이 좋습니다.\r\n", jsx(_components.code, {
          children: "produce"
        }), " 수정자는 단점은 없이 많은 이점을 제공할 수 있습니다."]
      }), "\n"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " state = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "(initialValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 값 읽기"
        }), "\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 값 설정"
        }), "\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), " = ", jsx(_components.span, {
          className: "hljs-number",
          children: "5"
        }), ";\r\n\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(anotherValue);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Mutable은 getter와 setter를 지원합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " user = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".firstName}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".lastName}"]
          }), "`"]
        }), ";\r\n  },\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "set"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "value"
        }), ") {\r\n    [", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "lastName"
        }), "] = value.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "split"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\" \""
        }), ");\r\n  },\r\n});\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "modifymutable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#modifymutable",
        children: "#"
      }), jsx(_components.code, {
        children: "modifyMutable"
      })]
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "v1.4.0에서 추가"
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { modifyMutable } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'solid-js/store'"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " modifyMutable<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "mutable"
        }), ": T, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "modifier"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state: T"
          }), ") =>"]
        }), " T): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["이 헬퍼 함수는 단일 ", jsx(_components.a, {
        href: "#batch",
        children: jsx(_components.code, {
          children: "batch"
        })
      }), "에서 (", jsx(_components.a, {
        href: "#createmutable",
        children: jsx(_components.code, {
          children: "createMutable"
        })
      }), "에서 반환하는) 변경 가능한 스토어를 여러 번 변경하는 것을 단순화함으로써, 의존관계에 있는 계산이 업데이트마다 실행되는 대신 한 번만 업데이트되도록 합니다.\r\n첫 번째 인수는 수정할 변경 가능한 스토어이며, 두 번째 인수는 ", jsx(_components.a, {
        href: "#reconcile",
        children: jsx(_components.code, {
          children: "reconcile"
        })
      }), " 또는 ", jsx(_components.a, {
        href: "#produce",
        children: jsx(_components.code, {
          children: "produce"
        })
      }), " 에서 반환된 것과 같은 스토어 수정자입니다.\r\n(커스텀 수정자 함수를 전달하는 경우, 해당 인수가 래핑되지 않은 스토어임을 조심해야 합니다.)"]
    }), "\n", jsx(_components.p, {
      children: "예를 들어, 변경 가능한 여러 필드에 의존성이 있는 UI가 있다고 가정해 보겠습니다:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-tsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " state = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\r\n  },\r\n});\r\n\r\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "Hello {state.user.firstName + ' ' + state.user.lastName}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          })]
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.em, {
        children: "n"
      }), " 개의 필드를 순서대로 수정하게 되면, UI는 ", jsx(_components.em, {
        children: "n"
      }), " 번 업데이트됩니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: ["state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Jake\""
        }), ";  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 업데이트 트리거"
        }), "\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "lastName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnson\""
        }), ";  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 또다른 업데이트 트리거"
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["단 한 번만 업데이트를 트리거하려면, 필드를 ", jsx(_components.code, {
        children: "batch"
      }), " 내에서 변경합니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "batch"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Jake\""
        }), ";\r\n  state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "lastName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnson\""
        }), ";\r\n});\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "modifyMutable"
      }), " 를 ", jsx(_components.code, {
        children: "reconcile"
      }), " 또는 ", jsx(_components.code, {
        children: "produce"
      }), " 와 결합하면, 유사한 작업을 수행하는 두 가지 방법을 제공할 수 있습니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// state.user 를 지정한 객체로 교체 (다른 필드들은 모두 삭제)"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "modifyMutable"
        }), "(state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "reconcile"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Jake\""
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnson\""
        }), ",\r\n}));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// batch에서 두 필드를 수정하며, 한 번의 업데이트만 트리거"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "modifyMutable"
        }), "(state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "produce"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "u"
          }), ") =>"]
        }), " {\r\n  u.", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Jake\""
        }), ";\r\n  u.", jsx(_components.span, {
          className: "hljs-property",
          children: "lastName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnson\""
        }), ";\r\n}));\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "component-apis",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#component-apis",
        children: "#"
      }), "Component APIs"]
    }), "\n", jsxs(_components.h2, {
      id: "createcontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcontext",
        children: "#"
      }), jsx(_components.code, {
        children: "createContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createContext } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T> {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "symbol"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Provider"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["props: { value: T; children: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            }), " }"]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defaultValue"
        }), ": T;\r\n}\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createContext<T>(defaultValue?: T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ">;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Solid에서 컨텍스트는 일종의 의존성 주입을 제공합니다. 중간 컴포넌트 props를 따라 데이터를 전달할 필요가 없도록 데이터를 저장하는데 사용됩니다."
    }), "\n", jsxs(_components.p, {
      children: ["이 함수는 ", jsx(_components.code, {
        children: "useContext"
      }), "와 함께 사용할 수 있는 새로운 컨텍스트 객체를 생성하고, ", jsx(_components.code, {
        children: "Provider"
      }), " 제어 흐름을 제공합니다.\r\n기본 컨텍스트는 계층 구조에서 ", jsx(_components.code, {
        children: "Provider"
      }), "를 찾을 수 없을 때 사용됩니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CounterContext"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createContext"
        }), "([{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " }, {}]);\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "CounterProvider"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": props.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " || ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " });\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " counter = [\r\n    state,\r\n    {\r\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "increment"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\r\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\r\n      },\r\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "decrement"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\r\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c - ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\r\n      },\r\n    },\r\n  ];\r\n\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\r\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "CounterContext.Provider"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "value"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{counter}"
            }), ">"]
          }), "\r\n      {props.children}\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "CounterContext.Provider"
            }), ">"]
          })]
        }), "\r\n  );\r\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["프로바이더에 전달된 값은 그대로 ", jsx(_components.code, {
        children: "useContext"
      }), "에 전달되며, 이로 인해 리액티브 표현식으로 래핑해도 작동하지 않습니다.\r\n시그널과 스토어를 JSX에서 액세스하는 대신 직접 전달해야 합니다."]
    }), "\n", jsxs(_components.h2, {
      id: "usecontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usecontext",
        children: "#"
      }), jsx(_components.code, {
        children: "useContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { useContext } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " useContext<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "context"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T>): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "props를 각 컴포넌트 함수를 통해 전달하지 않으면서도 깊숙히 전달하기 위해 컨텍스트를 가져옵니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, { increment, decrement }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useContext"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CounterContext"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "children",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#children",
        children: "#"
      }), jsx(_components.code, {
        children: "children"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { children } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResolvedChildren"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "fn: () => JSX.Element"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResolvedChildren"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "children"
      }), " 헬퍼는 JSX에서 ", jsx(_components.code, {
        children: "{props.children}"
      }), " 을 단 한 번만 사용해 다른 컴포넌트로 자식을 전달하는 경우를 제외한, 다른 모든 경우 ", jsx(_components.code, {
        children: "props.children"
      }), " 과의 복잡한 상호 작용을 위한 것입니다.\r\n일반적으로 ", jsx(_components.code, {
        children: "props.children"
      }), " 에 대한 getter를 다음과 같이 전달합니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " resolved = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["반환값은 자식을 나타내는 ", jsx(_components.a, {
        href: "#creatememo",
        children: "memo"
      }), " 이며, 자식이 변경될 때마다 업데이트됩니다.\r\n", jsx(_components.code, {
        children: "props.children"
      }), " 에 직접 접근하는 대신 memo를 사용하면, 일부 시나리오에서 몇 가지 중요한 이점이 있습니다.\r\n근본적인 문제는 JSX를 통해 컴포넌트 자식을 지정하는 경우, Solid는 자동으로 ", jsx(_components.code, {
        children: "props.children"
      }), "을 프로퍼티 getter로 정의하며, 이로 인해 ", jsx(_components.code, {
        children: "props.children"
      }), " 이 액세스될 때마다 자식이 생성(DOM이 생성)됩니다.\r\n이로 인한 두 가지 특징적인 결과는:"]
    }), "\n", jsxs(_components.ul, {
      children: ["\n", jsxs(_components.li, {
        children: [jsx(_components.code, {
          children: "props.children"
        }), " 에 여러 번 액세스하면 자식(및 관련된 DOM)이 여러 번 생성됩니다.\r\n이는 DOM을 복사하려는 경우에는 유용하지만(DOM 노드는 하나의 부모 엘리먼트에만 나타날 수 있음), 대부분의 경우 중복된 DOM 노드를 생성하게 됩니다.\r\n대신 ", jsx(_components.code, {
          children: "resolved()"
        }), " 를 여러 번 호출하게 되면, 같은 자식을 재사용하게 됩니다."]
      }), "\n", jsxs(_components.li, {
        children: [jsx(_components.code, {
          children: "props.children"
        }), " 를 추적 범위 외부에서 (예: 이벤트 핸들러에서) 액세스하는 경우, 절대 정리되지 않는 자식을 생성하게 됩니다.\r\n대신 ", jsx(_components.code, {
          children: "resolved()"
        }), " 를 호출하면 자식을 재사용하게 됩니다.\r\n또한 (다른 컴포넌트 같은) 다른 추적범위가 아닌, 현재 컴포넌트에서 자식이 추적되는 것을 보장합니다,"]
      }), "\n"]
    }), "\n", jsxs(_components.p, {
      children: ["또한 ", jsx(_components.code, {
        children: "children"
      }), " 헬퍼는 인수가 없는 함수를 호출하고 2차원 배열을 1차원 배열로 평탄화하여 자식을 결정합니다.\r\n예를 들어, ", jsx(_components.code, {
        children: "{signal() * 2}"
      }), "와 같이 JSX로 지정된 자식은 ", jsx(_components.code, {
        children: "props.children"
      }), " 에서 getter 함수 ", jsx(_components.code, {
        children: "() => count() * 2"
      }), " 로 래핑되지만, ", jsx(_components.code, {
        children: "count"
      }), " 시그널에 따라 ", jsx(_components.code, {
        children: "resolved"
      }), " 에서는 실제 숫자로 적절하게 평가됩니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "props.children"
      }), " 이 배열이 아닌 경우(JSX 태그가 자식을 하나만 가지는 경우), ", jsx(_components.code, {
        children: "children"
      }), " 헬퍼는 이를 배열로 정규화하지 않습니다.\r\n이는 단일 함수를 자식으로 전달하려는 경우 유용한데, ", jsx(_components.code, {
        children: "typeof resolved() === 'function'"
      }), " 을 통해 이를 감지할 수 있습니다.\r\n배열로 정규화하고 싶다면, ", jsx(_components.code, {
        children: "Array.isArray(resolved()) ? resolved() : [resolved()]"
      }), " 처럼 사용할 수 있습니다."]
    }), "\n", jsxs(_components.p, {
      children: ["다음은 자식을 렌더링하는 것 외에도 ", jsx(_components.code, {
        children: "Element"
      }), " 타입이 되는 모든 자식의 ", jsx(_components.code, {
        children: "class"
      }), " 속성을 자동으로 설정하는 예입니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-tsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " resolved = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " list = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolved"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (!", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "isArray"
        }), "(list)) list = [list];\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "for"
        }), " (", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " child ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "of"
        }), " list) child?.", jsx(_components.span, {
          className: "hljs-property",
          children: "setAttribute"
        }), "?.(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"class\""
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "myClass"
        }), "());\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{resolved()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "(이 방법은 별로 권장되지는 않습니다:\r\n일반적으로 props 또는 컨텍스트를 통해 원하는 클래스를 자식 컴포넌트로 전달하는 선언적 접근 방식을 따르는 것이 좋습니다.)"
    }), "\n", jsxs(_components.p, {
      children: ["반면에, JSX를 통해 ", jsx(_components.code, {
        children: "props.children"
      }), "을 다른 컴포넌트나 엘리먼트에 전달하는 경우, ", jsx(_components.code, {
        children: "children"
      }), " 헬퍼를 사용할 필요가 없습니다(경우에 따라서 원치 않는 경우도 있습니다)."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-tsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Wrapper"
        }), " = (", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") => {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{props.children}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), ";\r\n};\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "children"
      }), " 헬퍼의 중요한 측면은 ", jsx(_components.code, {
        children: "props.children"
      }), "에 바로 액세스하므로 자식을 강제로 생성하고 결정해야 한다는 것입니다.\r\n이는 ", jsx(_components.a, {
        href: "#show",
        children: jsx(_components.code, {
          children: "<Show>"
        })
      }), " 컴포넌트 내에서 자식을 사용하는 것과 같은 조건부 렌더링시에는 바람직하지 않을 수 있습니다.\r\n예를 들어, 다음 코드는 항상 자식을 평가합니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-tsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " resolved = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Show"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{visible()}"
            }), ">"]
          }), "{resolved()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Show"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<Show>"
      }), "가 자식을 렌더링할 때만 자식을 평가하고 싶다면, 컴포넌트 내부 혹은 ", jsx(_components.code, {
        children: "<Show>"
      }), " 내부 함수에서 ", jsx(_components.code, {
        children: "children"
      }), " 호출을 푸시합니다. 이렇게 되면 ", jsx(_components.code, {
        children: "when"
      }), " 조건이 true인 경우에만 자식을 평가합니다.\r\n또 다른 좋은 방법은 자식을 실제로 평가하고 싶은 경우에만 ", jsx(_components.code, {
        children: "props.children"
      }), "을 ", jsx(_components.code, {
        children: "children"
      }), " 헬퍼에 전달하는 것입니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " resolved = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "visible"
        }), "() && props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "lazy",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#lazy",
        children: "#"
      }), jsx(_components.code, {
        children: "lazy"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { lazy } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " lazy<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ">>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "default"
        }), ": T }>\r\n): T & { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "preload"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T> };\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["코드 스플리팅을 허용하기 위해 컴포넌트를 지연 로딩하는데 사용됩니다.\r\n컴포넌트는 렌더링될 때까지 로드되지 않습니다.\r\n지연 로딩된 컴포넌트는 props를 받는 등의 작업을 정적으로 임프토된 컴포넌트와 동일하게 사용할 수 있습니다.\r\n지연 컴포넌트는 ", jsx(_components.code, {
        children: "<Suspense>"
      }), "를 트리거합니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 임포트 래핑"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ComponentA"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "lazy"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "import"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./ComponentA\""
        }), "));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// JSX에서 사용"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ComponentA"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "title"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.title}"
            }), " />"]
          })
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createuniqueid",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createuniqueid",
        children: "#"
      }), jsx(_components.code, {
        children: "createUniqueId"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createUniqueId } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createUniqueId"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "서버/브라우저 모두에서 안정적으로 사용할 수 있는 범용 ID 생성기."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " id = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createUniqueId"
        }), "();\n"]
      })
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: [jsx(_components.strong, {
          children: "참고"
        }), " 서버에서는 하이드레이션 가능한 컴포넌트에서만 작동합니다."]
      }), "\n"]
    }), "\n", jsxs(_components.h1, {
      id: "secondary-primitives",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#secondary-primitives",
        children: "#"
      }), "Secondary Primitives"]
    }), "\n", jsx(_components.p, {
      children: "처음 앱을 만들때는 필요 없을 수 있지만, 있으면 유용한 도구들입니다."
    }), "\n", jsxs(_components.h2, {
      id: "createdeferred",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createdeferred",
        children: "#"
      }), jsx(_components.code, {
        children: "createDeferred"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createDeferred } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createDeferred<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  options?: {\r\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\r\n    equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ");\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["브라우저가 아이들 상태일 때 다운스트림 변경 사항을 알려주는 읽기 전용 계산을 생성합니다.\r\n", jsx(_components.code, {
        children: "timeoutMs"
      }), " 는 강제 업데이트를 하기 전에 대기하는 최대 시간입니다."]
    }), "\n", jsxs(_components.h2, {
      id: "createrendereffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createrendereffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createRenderEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createRenderEffect } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRenderEffect<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T, value?: T): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["render 이펙트는 일반 이펙트(", jsx(_components.a, {
        href: "#createeffect",
        children: jsx(_components.code, {
          children: "createEffect"
        })
      }), "에 의해 생성)와 유사한 계산이지만, Solid가 이펙트 함수의 첫 실행을 예약할 때 차이가 있습니다.\r\n", jsx(_components.code, {
        children: "createEffect"
      }), "는 현재 렌더링 단계가 완료될 때까지 기다리지만, ", jsx(_components.code, {
        children: "createRenderEffect"
      }), "는 함수를 즉시 실행합니다.\r\n따라서 이펙트는 DOM 엘리먼트가 생성되고 업데이트될 때 실행되지만, 관심있는 특정 엘리먼트가 생성되기 전, 그리고 이 엘리먼트가 도큐먼트에 연결되기 전에 실행될 수 있습니다.\r\n특히 ", jsx(_components.a, {
        href: "#ref",
        children: jsx(_components.code, {
          children: "ref"
        })
      }), "는 초기 이펙트 호출 전에는 설정되지 않습니다.\r\n실제로 Solid는 ", jsx(_components.code, {
        children: "ref"
      }), " 설정을 포함해 렌더링 단계 자체를 구현하기 위해 ", jsx(_components.code, {
        children: "createRenderEffect"
      }), "를 사용합니다."]
    }), "\n", jsxs(_components.p, {
      children: ["render 이펙트에 대한 리액티브 업데이트는 이펙트와 동일합니다: 리액티브 변경(예: 단일 시그널 업데이트, 일괄 변경, 전체 렌더링 단계 동안의 변경 집합)에 대한 응답으로 대기열에 추가되고, 나중에 단일 ", jsxs(_components.a, {
        href: "#batch",
        children: ["일괄", "batch"]
      }), "로 이펙트와 함께 실행됩니다.\r\n특히, render 이펙트 내의 모든 시그널 업데이트 일괄 처리됩니다."]
    }), "\n", jsxs(_components.p, {
      children: ["다음은 동작의 예입니다. (", jsx(_components.a, {
        href: "#createeffect",
        children: jsx(_components.code, {
          children: "createEffect"
        })
      }), "의 예와 비교해 보세요.)"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이 코드가 컴포넌트 함수에 있다고 가정하고, 렌더링 단계의 일부입니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [count, setCount] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이 이펙트는 처음과 변경시에 count 를 출력합니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRenderEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count =\""
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "()));\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// render 이펙트는 즉시 실행되며, `count = 0`을 출력합니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"hello\""
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 아직 이펙트 미실행"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ");  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 아직 이펙트 미실행"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "queueMicrotask"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 이제 `count = 2` 출력"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"microtask\""
        }), ");\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "3"
        }), ");  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 즉시 `count = 3` 출력"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"goodbye\""
        }), ");\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// --- 전체 출력: ---"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// count = 0   [createEffect와 비교해 유일하게 추가된 라인]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// hello"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// count = 2"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// microtask"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// count = 3"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// goodbye"
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createEffect"
      }), "와 마찬가지로, 이펙트 함수는 마지막 이펙트 함수 실행에서 반환된 값을 인수로 사용해 호출됩니다.\r\n첫 실행인 경우에는 ", jsx(_components.code, {
        children: "createRenderEffect"
      }), "호출시 사용한 옵셔널 두 번째 인수를 사용해 호출됩니다."]
    }), "\n", jsxs(_components.h2, {
      id: "createcomputed",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcomputed",
        children: "#"
      }), jsx(_components.code, {
        children: "createComputed"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createComputed } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createComputed<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T, value?: T): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createComputed"
      }), "는 추적 범위에서 지정된 함수를 즉시 실행하는 새 계산을 생성하여, 디펜던시를 자동으로 추적하고 디펜던시가 변경될 때마다 함수를 자동으로 다시 실행합니다.\r\n함수는 함수의 마지막 실행에서 반환된 값을 인수로 사용해 호출되며, 첫번째 호출에서는 ", jsx(_components.code, {
        children: "createComputed"
      }), "의 옵셔널 두 번째 인수를 사용해 호출됩니다.\r\n그 외의 경우 함수의 반환 값은 노출되지 않습니다. 특히, ", jsx(_components.code, {
        children: "createComputed"
      }), "는 반환 값이 없습니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createComputed"
      }), "는 Soild에서 가장 즉각적인 형태의 반응형이며, 다른 프리미티브를 구현하는데 가장 유용합니다. (예를 들어, 일부 다른 Solid 프리미티브들은 ", jsx(_components.code, {
        children: "createComputed"
      }), "를 사용해 구현되어 있습니다.)\r\n하지만, ", jsx(_components.code, {
        children: "createComputed"
      }), "는 다른 리액티브 프리미티브보다 더 많은 불필요한 업데이트를 쉽게 일으킬 수 있기 때문에 주의해서 사용해야 합니다.\r\n사용 전에, 밀접하게 관련되어 있는 ", jsx(_components.a, {
        href: "#creatememo",
        children: jsx(_components.code, {
          children: "createMemo"
        })
      }), "와 ", jsx(_components.a, {
        href: "#createrendereffect",
        children: jsx(_components.code, {
          children: "createRenderEffect"
        })
      }), "을 고려해보세요."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createMemo"
      }), "와 마찬가지로, ", jsx(_components.code, {
        children: "createComputed"
      }), "는 업데이트시 (", jsx(_components.a, {
        href: "#batch",
        children: "batch"
      }), ", ", jsx(_components.a, {
        href: "#createeffect",
        children: "이펙트"
      }), ", ", jsx(_components.a, {
        href: "#usetransition",
        children: "트랜지션"
      }), "이 아닌 경우) 즉시 함수를 호출합니다.\r\n하지만 ", jsx(_components.code, {
        children: "createMemo"
      }), " 함수는 순수(어떤 시그널도 설정하지 않아야 함)해야 하지만, ", jsx(_components.code, {
        children: "createComputed"
      }), " 함수는 시그널을 설정할 수 있습니다.\r\n이와 관련해, ", jsx(_components.code, {
        children: "createMemo"
      }), "는 함수 반환 값에 대해 읽기 전용 시그널을 제공하는 반면, ", jsx(_components.code, {
        children: "createComputed"
      }), "로 동일한 작업을 수행하려면 함수 내에서 시그널을 설정해야 합니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createComputed"
      }), "내에서 시그널을 업데이트하면 불필요(", jsx(_components.a, {
        href: "#batch",
        children: jsx(_components.code, {
          children: "batch"
        })
      }), ", ", jsx(_components.a, {
        href: "#untrack",
        children: jsx(_components.code, {
          children: "untrack"
        })
      }), " 등으로 래핑해 처리하지 않은 경우)할 수도 있는 리액티브 업데이트를 즉시 트리거합니다.\r\n반면에 순수 함수와 ", jsx(_components.code, {
        children: "createMemo"
      }), "를 사용할 수 있다면, Solid가 메모 업데이트 실행 순서를 최적화하기 때문에 이것이 더 효율적일 수 있습니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createRenderEffect"
      }), "와 마찬가지로, ", jsx(_components.code, {
        children: "createComputed"
      }), "는 처음에는 해당 함수를 즉시 실행하지만, 업데이트가 수행되는 방식이 다릅니다.\r\n일반적으로 ", jsx(_components.code, {
        children: "createComputed"
      }), "는 즉시 업데이트하지만, ", jsx(_components.code, {
        children: "createRenderEffect"
      }), "는 현재 렌더링 단계 후에 ", jsx(_components.code, {
        children: "createEffect"
      }), "와 함께 단일 ", jsx(_components.code, {
        children: "batch"
      }), "로 실행되도록 대기열을 업데이트합니다.\r\n따라서 ", jsx(_components.code, {
        children: "createRenderEffect"
      }), "는 전체 업데이트를 더 적게 수행할 수 있지만, 약간 덜 즉각적입니다."]
    }), "\n", jsxs(_components.h2, {
      id: "createreaction",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createreaction",
        children: "#"
      }), jsx(_components.code, {
        children: "createReaction"
      })]
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "v1.3.0 추가"
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createReaction } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createReaction"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["onInvalidate: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["fn: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "때로는 추적과 재실행을 분리하는 것이 유용합니다.\r\n이 프리미티브는 반환된 추적 함수에 의해 래핑된 표현식이 변경 사항에 대해 알림을 받을 때 처음 실행될 사이드 이펙트를 등록합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [s, set] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"start\""
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " track = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createReaction"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"something\""
        }), "));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 다음에 s가 변경되면 리액션을 실행합니다."
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "track"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "s"
        }), "());\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "set"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"end\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// \"something\""
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "set"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"final\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 리액션은 첫 업데이트에서만 실행되기 때문에 작동하지 않으며, track 을 다시 호출해야 합니다."
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createselector",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createselector",
        children: "#"
      }), jsx(_components.code, {
        children: "createSelector"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createSelector } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSelector<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  fn?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "a: U, b: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), "\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "k: U"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "값과 일치하는 키가 들어오거나 나가는 경우에만 구독자에게 알리는 조건부 시그널을 생성합니다.\r\nO(n) 대신 O(1) 연산을 수행하기 때문에, 위임된 선택 상태에 유용하게 사용할 수 있습니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " isSelected = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSelector"
        }), "(selectedId);\r\n\r\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{list()}"
            }), ">"]
          }), "\r\n  {(item) => ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "classList"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "active:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "isSelected"
            }), "(", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), ") }}>"]
          }), "{item.name}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "}\r\n", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "rendering",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendering",
        children: "#"
      }), "Rendering"]
    }), "\n", jsxs(_components.p, {
      children: ["사용되는 함수들은 ", jsx(_components.code, {
        children: "solid-js/web"
      }), "에서 가져옵니다."]
    }), "\n", jsxs(_components.h2, {
      id: "render",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#render",
        children: "#"
      }), jsx(_components.code, {
        children: "render"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { render } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'solid-js/web'"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "code: () => JSX.Element, element: MountableElement"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["이 함수는 브라우저 앱 진입점입니다.\r\n마운트할 최상위 컴포넌트나 함수, 그리고 마운트할 대상 엘리먼트를 지정합니다.\r\n이 엘리먼트는 비워두는 것이 좋습니다:\r\n", jsx(_components.code, {
        children: "render"
      }), " 실행 중에 자식을 추가하기 때문에, 반환되는 dispose 함수는 모든 자식들을 삭제합니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 또는"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "App"
            }), "/>"]
          })
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["첫 번째 인수가 함수라는 것이 중요합니다:\r\n", jsx(_components.code, {
        children: "render"
      }), "가 루트를 설정하고 ", jsx(_components.code, {
        children: "App"
      }), " 내에서 시그널 디펜던시를 추적하기 전에 ", jsx(_components.code, {
        children: "App"
      }), "이 실행되기 때문에, ", jsx(_components.code, {
        children: "render(<App/>, ...)"
      }), " 처럼 JSX를 직접 전달하면 안됩니다."]
    }), "\n", jsxs(_components.h2, {
      id: "hydrate",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#hydrate",
        children: "#"
      }), jsx(_components.code, {
        children: "hydrate"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { hydrate } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "fn: () => JSX.Element, node: MountableElement"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["이 메서드는 DOM에 이미 렌더링된 것을 다시 하이드레이션 하려고 시도한다는 점만 빼면 ", jsx(_components.code, {
        children: "render"
      }), "와 유사합니다.\r\n브라우저에서 초기화할 때 페이지는 이미 서버에서 렌더링된 상태입니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostring",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostring",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToString"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { renderToString } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToString<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  options?: {\r\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n    renderId?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "문자열로 렌더링하며, 동기식으로 작동합니다.\r\n이 함수는 또한 프로그레시브 하이드레이션을 위한 스크립트 태그를 생성합니다.\r\n옵션에는 페이지가 로드되기 전에 수신하고 하이드레이션시에 실행할 이벤트 이름과, 스크립트 태그에 넣을 nonce가 포함됩니다."
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "renderId"
      }), " 는 여러 최상위 루트가 있는 경우 네임스페이스 렌더링에 사용됩니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToString"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostringasync",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostringasync",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToStringAsync"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { renderToStringAsync } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToStringAsync<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  options?: {\r\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\r\n    renderId?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ">;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["결과를 반환하기 전에 모든 ", jsx(_components.code, {
        children: "<Suspense>"
      }), " 경계가 해결될 때까지 대기한다는 점만 제외하면 ", jsx(_components.code, {
        children: "renderToString"
      }), "과 동일합니다.\r\n리소스 데이터는 자동으로 스크립트 태그로 직렬화되며, 클라이언트 로드시 하이드레이트됩니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "renderId"
      }), " 는 여러 최상위 루트가 있는 경우 네임스페이스 렌더링에 사용됩니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToStringAsync"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostream",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostream",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToStream"
      })]
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "v1.3.0 추가"
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { renderToStream } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToStream<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  options?: {\r\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n    renderId?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n    onCompleteShell?: ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n    onCompleteAll?: ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n  }\r\n): {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "pipe"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["writable: { write: (v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            }), ") => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), " }"]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "pipeTo"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "writable: WritableStream"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n};\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "이 메서드는 스트립으로 렌더링합니다.\r\nSuspense 폴백 플레이스홀더를 포함하여 컨텐츠를 동기적으로 렌더링한 다음, 완려되면 비동기 리소스에서 데이터과 HTML을 계속 스트리밍합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// node"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToStream"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ").", jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipe"
        }), "(res);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// web stream"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " { readable, writable } = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "TransformStream"
        }), "();\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToStream"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ").", jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipeTo"
        }), "(writable);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "onCompleteShell"
      }), "은 스트림에 대한 첫 플러시를 브라우저에 쓰기전에, 동기 렌더링이 완료되면 실행됩니다.\r\n", jsx(_components.code, {
        children: "onCompleteAll"
      }), "은 모든 서버 Suspense 경계가 해결되면 호출됩니다.\r\n", jsx(_components.code, {
        children: "renderId"
      }), " 는 여러 최상위 루트가 있는 경우 네임스페이스 렌더링에 사용됩니다."]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: ["이 API는 이전의 ", jsx(_components.code, {
          children: "pipeToWritable"
        }), ", ", jsx(_components.code, {
          children: "pipeToNodeWritable"
        }), " API를 대체합니다."]
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "isserver",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#isserver",
        children: "#"
      }), jsx(_components.code, {
        children: "isServer"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { isServer } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "isServer"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "코드가 서버 또는 브라우저 번들로 실행되고 있음을 나타냅니다.\r\n기본 런타임이 이 값을 boolean 상수값으로 익스포트하기 때문에, 번들러는 이 코드와 해당 번들에서 사용된 임포트들을 제거할 수 있습니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (isServer) {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 브라우저 번들에 포함되지 않음"
        }), "\r\n} ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "else"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 서버에서 실행되지 않음"
        }), "\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "hydrationscript",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#hydrationscript",
        children: "#"
      }), jsx(_components.code, {
        children: "HydrationScript"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { generateHydrationScript, ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "HydrationScript"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "generateHydrationScript"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["options: {\r\n  nonce?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "string"
          }), ";\r\n  eventNames?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "string"
          }), "[];\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "HydrationScript"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\r\n  nonce?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "string"
          }), ";\r\n  eventNames?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "string"
          }), "[];\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["하이드레이션 스크립트는 Solid 런타임이 로드되기 전에 하이드레이션을 부트스트랩하기 위해 페이지에 배치되어야 하는 특별한 스크립트입니다.\r\nHTML 문자열에서 호출 및 삽입할 수 있는 함수로 제공되거나, ", jsx(_components.code, {
        children: "<html>"
      }), " 태그에서 JSX를 렌더링하는 경우 컴포넌트로 제공됩니다."]
    }), "\n", jsxs(_components.p, {
      children: ["옵션에는 스크립트 태그에 추가할 ", jsx(_components.code, {
        children: "nounce"
      }), ", 그리고 스크립트가 로드된 후 하이드레이션 재실행 중에 캡쳐해야하는 이벤트 이름들이 있습니다.\r\n이 이벤트들은 구성 및 버블링되는 대부분의 UI 이벤트를 포함하는 Solid가 위임하는 이벤트로 한정됩니다.\r\n기본적으로는 ", jsx(_components.code, {
        children: "click"
      }), ", ", jsx(_components.code, {
        children: "input"
      }), " 이벤트만 있습니다."]
    }), "\n", jsxs(_components.h1, {
      id: "control-flow",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#control-flow",
        children: "#"
      }), "Control Flow"]
    }), "\n", jsxs(_components.p, {
      children: ["리액티브 제어 흐름이 성능을 발휘하려면, 엘리먼트가 생성되는 방식을 제어해야 합니다.\r\n예를 들어, ", jsx(_components.code, {
        children: "array.map"
      }), "을 호출하면 항상 전체 배열을 매핑하므로 비효율적입니다."]
    }), "\n", jsx(_components.p, {
      children: "이는 헬퍼 함수를 의미합니다.\r\n이들을 컴포넌트로 래핑하는 것은 간결한 템플릿을 위한 편리한 방법이며, 사용자가 커스텀 제어 흐름 컴포넌트를 만들어 구성할 수 있도록 합니다."
    }), "\n", jsxs(_components.p, {
      children: ["이러한 기본 제어 흐름 컴포넌트들은 자동으로 임포트됩니다.\r\n", jsx(_components.code, {
        children: "Portal"
      }), ", ", jsx(_components.code, {
        children: "Dynamic"
      }), "을 제외한 모든 항목들은 ", jsx(_components.code, {
        children: "solid-js"
      }), "와 ", jsx(_components.code, {
        children: "solid-js/web"
      }), "에서 익스포트됩니다.\r\nDOM 전용인 ", jsx(_components.code, {
        children: "Portal"
      }), "과 ", jsx(_components.code, {
        children: "Dynamic"
      }), "은 ", jsx(_components.code, {
        children: "solid-js/web"
      }), "에서 익스포트됩니다."]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "참고: 제어 흐름의 모든 콜백/렌더 함수는 추적되지 않습니다. 이 덕분에 중첩된 상태를 생성할 수 있으며, 리액션을 더 잘 분리할 수 있게 됩니다."
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "for",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#for",
        children: "#"
      }), jsx(_components.code, {
        children: "<For>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\r\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: T, index: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\r\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "변경된 항목만 효율적으로 업데이트하는 참조 키 루프. 콜백 함수의 첫 번째 인수는 현재 항목이 전달됩니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{item}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "옵셔널인 두 번째 인수는 인덱스 시그널이 전달됩니다:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item, index"
          }), ") =>"]
        }), " (\r\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\r\n      #{index()} {item}\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n  )}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "show",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#show",
        children: "#"
      }), jsx(_components.code, {
        children: "<Show>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\r\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\r\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Show 제어 흐름은 뷰의 일부를 조건부로 렌더링하는 데 사용됩니다: ", jsx(_components.code, {
        children: "when"
      }), " 조건이 참인 경우 ", jsx(_components.code, {
        children: "children"
      }), "을 렌더링하며, 그렇지 않은 경우  ", jsx(_components.code, {
        children: "fallback"
      }), "을 렌더링합니다.\r\n삼항 연산자(", jsx(_components.code, {
        children: "when ? children : fallback"
      }), ")와 유사하지만 JSX 템플링에는 이 방법이 좋습니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " > ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "My Content", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Show는 특정 데이터 모델을 표시하는데도 사용할 수 있습니다.\r\n예를 들어, 아래 함수는 user 모델이 교체될 때마다 다시 실행됩니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "user"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{user.firstName}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "switchmatch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#switchmatch",
        children: "#"
      }), jsx(_components.code, {
        children: "<Switch>"
      }), "/", jsx(_components.code, {
        children: "<Match>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Match"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Switch"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\r\n  fallback?: JSX.Element;\r\n  children: JSX.Element;\r\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T> = {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\r\n};\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Match"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T>);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "2개 이상의 상호 배타적인 조건이 있는 유용합니다.\r\n예를 들어, 기본 라우팅에 사용할 수 있습니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Not Found", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"home\""
            }), "}>"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Home"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"settings\""
            }), "}>"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Settings"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Match는 함수 형태의 자식도 지원합니다."
    }), "\n", jsxs(_components.h2, {
      id: "index",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#index",
        children: "#"
      }), jsx(_components.code, {
        children: "<Index>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\r\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: () => T, index: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\r\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "키가 없는 리스트 반복에 사용하며, 렌더링된 노드는 배열 인덱스로 키가 지정됩니다.\r\n데이터가 프리미티브로 구성이 되어 있고, 값 대신 인덱스가 고정되어 있는 경우와 같이 개념적인 키가 없을 때 유용합니다."
    }), "\n", jsx(_components.p, {
      children: "아래 코드에서 item은 시그널입니다:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{item()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "2번째 인수는 index를 나타냅니다:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item, index"
          }), ") =>"]
        }), " (\r\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\r\n      #{index} {item()}\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n  )}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "errorboundary",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#errorboundary",
        children: "#"
      }), jsx(_components.code, {
        children: "<ErrorBoundary>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ErrorBoundary"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\r\n  fallback: JSX.Element | ((err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ", reset: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          }), ") => JSX.Element);\r\n  children: JSX.Element;\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "처리되지 않은 에러를 캐치해서 대체 콘텐츠를 렌더링합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Something went terribly wrong", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " />"]
          })
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "또한 에러와 리셋 함수를 전달하는 콜백 형식도 지원합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), "\r\n  fallback={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "err, reset"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{reset}"
            }), ">"]
          }), "Error: {err.toString()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n>\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " />"]
          })
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspense",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspense",
        children: "#"
      }), jsx(_components.code, {
        children: "<Suspense>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Suspense"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\r\n  fallback?: JSX.Element;\r\n  children: JSX.Element;\r\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["자식에서 읽는 모든 리소스를 추적하고 해결될 때까지 폴백 플레이스 홀더를 표시하는 컴포넌트입니다.\r\n", jsx(_components.code, {
        children: "Suspense"
      }), "가 ", jsx(_components.code, {
        children: "Show"
      }), "와 다른 점은, 현재 DOM에 없더라도 두 컴포넌트가 동시에 존재한다는 점에서 논블로킹이라는 점입니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "AsyncComponent"
            }), " />"]
          })
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspenselist-실험-단계",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspenselist-실험-단계",
        children: "#"
      }), jsx(_components.code, {
        children: "<SuspenseList>"
      }), " (실험 단계)"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "SuspenseList"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\r\n  children: JSX.Element;\r\n  revealOrder: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"forwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"backwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"together\""
          }), ";\r\n  tail?: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"collapsed\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"hidden\""
          }), ";\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "SuspenseList"
      }), "는 여러 병렬 ", jsx(_components.code, {
        children: "Suspense"
      }), "와 ", jsx(_components.code, {
        children: "SuspenseList"
      }), " 컴포넌트를 조정할 수 있습니다.\r\n레이아웃 스래싱을 줄이기 위해 컨텐츠가 표시되는 순서를 제어하고, 폴백 상태를 축소하거나 숨길수 있는 옵션이 있습니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), " revealOrder=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"forwards\""
        }), " tail=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"collapsed\""
        }), ">\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileDetails"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "user"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.user}"
            }), " />"]
          })
        }), "\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Loading posts...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTimeline"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "posts"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.posts}"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Loading fun facts...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTrivia"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "trivia"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.trivia}"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "SuspenseList 는 아직 실험 단계이며, SSR 을 완전하게 지원하지 않습니다."
    }), "\n", jsxs(_components.h2, {
      id: "dynamic",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#dynamic",
        children: "#"
      }), jsx(_components.code, {
        children: "<Dynamic>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), "<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T & {\r\n    children?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\r\n    component?: ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<T> | ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | keyof ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "IntrinsicElements"
        }), ";\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "이 컴포넌트를 사용하면 임의의 컴포넌트 또는 태그를 삽입하고 props를 전달할 수 있습니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), " component={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "component"
        }), "} someProp={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "something"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "portal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#portal",
        children: "#"
      }), jsx(_components.code, {
        children: "<Portal>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Portal"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\r\n  mount?: Node;\r\n  useShadow?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\r\n  isSVG?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\r\n  children: JSX.Element;\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Text"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "mount 노드에 컴포넌트를 삽입합니다.\r\n페이지 레이아웃 외부에 모달을 삽입는데 유용하게 사용할 수 있으며, 이벤트는 컴포넌트 계층을 통해 전파됩니다."
    }), "\n", jsxs(_components.p, {
      children: ["대상이 ", jsx(_components.code, {
        children: "HTMLHeadElement"
      }), "가 아니라면 Portal 은 ", jsx(_components.code, {
        children: "<div>"
      }), "에 마운트됩니다.\r\n", jsx(_components.code, {
        children: "useShadow"
      }), "는 스타일 격리를 위해 섀도우 루트에 엘리먼트를 배치하고, SVG 엘리먼트에 삽입하는 경우 ", jsx(_components.code, {
        children: "<div>"
      }), "가 삽입되지 않도록 ", jsx(_components.code, {
        children: "isSVG"
      }), " 설정이 필요합니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), " mount={", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"modal\""
        }), ")}>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "My Content", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "특별한-jsx-속성",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#특별한-jsx-속성",
        children: "#"
      }), "특별한 JSX 속성"]
    }), "\n", jsx(_components.p, {
      children: "일반적으로 Solid는 DOM 컨벤션을 지키려고 합니다.\r\n대부분의 props는 기본 엘리먼트의 속성 및 웹 컴포넌트의 프로퍼티로 취급되지만, 그 중 일부는 특별한 동작을 합니다."
    }), "\n", jsx(_components.p, {
      children: "타입스크립트 사용시 커스텀 네임스페이스 속성은 Solid의 JSX 네임스페이스를 확장해야 합니다:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// use:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitProperties"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// prop:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitAttributes"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// attr:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomEvents"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// on:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomCaptureEvents"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// oncapture:____"
        }), "\r\n    }\r\n  }\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "ref",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#ref",
        children: "#"
      }), jsx(_components.code, {
        children: "ref"
      })]
    }), "\n", jsx(_components.p, {
      children: "ref는 JSX의 기본 DOM 엘리먼트에 액세스하기 위한 방법입니다.\r\n엘리먼트를 변수에 할당할 수도 있지만, JSX의 플로우에 컴포넌트를 그대로 두는 것이 더 좋습니다.\r\nref는 렌더링 시점에 엘리먼트가 DOM에 연결되기 전에 할당됩니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// ref에 의해 직접 할당되는 변수"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " myDiv;\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// onMount 또는 createEffect를 사용해 DOM에 연결된 후 읽음"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(myDiv));\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{myDiv}"
            }), " />"]
          })
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 또는, 콜백 함수 사용 (DOM에 연결되기 전에 호출됨)"
        }), "\r\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{el"
            }), " =>"]
          }), " console.log(el)} />"]
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "ref는 컴포넌트에서도 사용할 수 있으며, 다른 쪽에도 부착되어야 합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "MyComp"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.ref}"
            }), " />"]
          })
        }), ";\r\n}\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "App"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " myDiv;\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(myDiv.", jsx(_components.span, {
          className: "hljs-property",
          children: "clientWidth"
        }), "));\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{myDiv}"
            }), " />"]
          })
        }), ";\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "classlist",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#classlist",
        children: "#"
      }), jsx(_components.code, {
        children: "classList"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Solid는 엘리먼트의 ", jsx(_components.code, {
        children: "class"
      }), "를 설정하기 위해 ", jsx(_components.code, {
        children: "class"
      }), "와 ", jsx(_components.code, {
        children: "classList"
      }), " 속성을 제공합니다."]
    }), "\n", jsxs(_components.p, {
      children: ["먼저, 다른 속성들처럼 ", jsx(_components.code, {
        children: "class=..."
      }), "를 사용합니다. 예를 들면:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 2개의 정적 class"
        }), "\r\n<div ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "class"
        }), "=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"active editing\""
        }), " />\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 필요없는 경우 class 속성을 삭제하는 하나의 동적 class"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "class"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.active"
            }), " ? '", jsx(_components.span, {
              className: "hljs-attr",
              children: "active"
            }), "' ", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "undefined"
            }), "} />"]
          })
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 2개의 동적 class"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "class"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "`${", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.active"
            }), " ? '", jsx(_components.span, {
              className: "hljs-attr",
              children: "active"
            }), "' ", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ''} ${", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.currentId"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "row.id"
            }), " ? '", jsx(_components.span, {
              className: "hljs-attr",
              children: "editing"
            }), "' ", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ''}} />"]
          })
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["(참고로 ", jsx(_components.code, {
        children: "className=..."
      }), "는 Solid 1.4 부터 더 이상 사용되지 않습니다.)"]
    }), "\n", jsxs(_components.p, {
      children: ["대신 ", jsx(_components.code, {
        children: "classList"
      }), " 속성을 사용하면 각 키는 class 이고, 해당 class 를 포함할지 여부를 나타내는 boolean 형식의 값을 가지는 객체를 지정할 수 있습니다.\r\n예를 들면 (위의 마지막 예제에 해당함):"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div\r\n  classList={{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "active"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "active"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "editing"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentId"
        }), " === row.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), " }}\r\n/>\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["이 예제는 해당 boolean 값이 변경될 때만 ", jsx(_components.a, {
        href: "https://developer.mozilla.org/en-US/docs/Web/API/DOMTokenList/toggle",
        children: jsx(_components.code, {
          children: "element.classList.toggle"
        })
      }), " 을 동적으로 호출하여 각 class 를 켜거나 끄는 ", jsx(_components.a, {
        href: "#createrendereffect",
        children: "렌더 이펙트"
      }), "로 컴파일됩니다.\r\n예를 들어, ", jsx(_components.code, {
        children: "state.active"
      }), "가 ", jsx(_components.code, {
        children: "true"
      }), "가 되면, 엘리먼트는 ", jsx(_components.code, {
        children: "active"
      }), " class를 얻게 됩니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "classList"
      }), "에 전달되는 값은 적절한 객체로 평가되는 모든 표현식(시그널 getter 포함)이 가능합니다.\r\n몇 가지 예를 들면:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 동적 class 이름, 값"
        }), "\r\n<div classList={{ [", jsx(_components.span, {
          className: "hljs-title function_",
          children: "className"
        }), "()]: ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "classOn"
        }), "() }} />;\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 시그널 class 리스트"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [classes, setClasses] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "({});\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setClasses"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " ({...c, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "active"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), "}));\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "classList"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{classes()}"
            }), " />"]
          })
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "class"
      }), "와 ", jsx(_components.code, {
        children: "classList"
      }), "를 섞어쓸 수는 있지만 위험합니다.\r\n안전한 상황은 ", jsx(_components.code, {
        children: "class"
      }), "가 정적 문자열로 설정하거나 설정하지 않고, ", jsx(_components.code, {
        children: "classList"
      }), "가 리액티브한 경우입니다.\r\n(", jsx(_components.code, {
        children: "class"
      }), " 는 ", jsx(_components.code, {
        children: "class={baseClass()}"
      }), "처럼 정적 계산 값으로 설정할 수도 있지만, ", jsx(_components.code, {
        children: "classList"
      }), " 보다는 앞에 설정해야 합니다)\r\n만일 ", jsx(_components.code, {
        children: "class"
      }), "와 ", jsx(_components.code, {
        children: "classList"
      }), " 모두 리액티브하다면, 예상치 못한 동작이 발생할 수 있습니다:\r\n", jsx(_components.code, {
        children: "class"
      }), " 값이 변경되면, Solid 는 전체 ", jsx(_components.code, {
        children: "class"
      }), " 속성을 설정하므로, ", jsx(_components.code, {
        children: "classList"
      }), "에서 설정된 모든 토글을 덮어쓰게 됩니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "classList"
      }), "는 컴파일 타임 속성이기 때문에, ", jsx(_components.code, {
        children: "<div {...props} />"
      }), " 과 같은 스프레드 연산자나 ", jsx(_components.code, {
        children: "<Dynamic>"
      }), "내에서는 작동하지 않습니다."]
    }), "\n", jsxs(_components.h2, {
      id: "style",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#style",
        children: "#"
      }), jsx(_components.code, {
        children: "style"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Solid의 ", jsx(_components.code, {
        children: "style"
      }), " 속성에 CSS 문자열이나 키가 CSS 속성 이름인 객체를 사용할 수 있습니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 문자열"
        }), "\r\n<div style={", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`color: green; height: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.height}"
          }), "px`"]
        }), "} />\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 객체"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), "\r\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "color:"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "green"
            }), "\",\r\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "height:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.height"
            }), " + \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "px"
            }), "\" }}\r\n/>"]
          })
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsxs(_components.a, {
        href: "https://reactjs.org/docs/dom-elements.html#style",
        children: ["리액트의 ", jsx(_components.code, {
          children: "style"
        }), " 속성"]
      }), "과 달리 Solid는 내부적으로 ", jsx(_components.code, {
        children: "element.style.setProperty"
      }), "를 사용합니다.\r\n즉, ", jsx(_components.code, {
        children: "backgroundColor"
      }), "와 같은 자바스크립트 카멜 케이스 버전이 아닌 ", jsx(_components.code, {
        children: "\"background-color\""
      }), "와 같은 소문자이면서 ", jsx(_components.code, {
        children: "-"
      }), "로 구분된 속성 이름을 사용해야 합니다.\r\n이는 실제로 더 나은 성능과 SSR 출력의 일관성으로 이어집니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 문자열"
        }), "\r\n<div style={", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`color: green; background-color: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.color}"
          }), "; height: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.height}"
          }), "px`"]
        }), "} />\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 객체"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), "\r\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "color:"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "green"
            }), "\",\r\n  \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "background-color"
            }), "\"", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.color"
            }), ",\r\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "height:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.height"
            }), " + \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "px"
            }), "\" }}\r\n/>"]
          })
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "또한 CSS 변수도 설정할 수 있습니다. 예를 들면:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// css 변수 설정"
        }), "\r\n<div style={{ ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"--my-custom-color\""
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "themeColor"
        }), " }} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "innerhtmltextcontent",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#innerhtmltextcontent",
        children: "#"
      }), jsx(_components.code, {
        children: "innerHTML"
      }), "/", jsx(_components.code, {
        children: "textContent"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["이는 해당 프로퍼티와 동일하게 문자열을 설정하면 작동합니다.\r\n", jsx(_components.strong, {
        children: "조심하세요!!"
      }), " ", jsx(_components.code, {
        children: "innerHTML"
      }), "에 설정하는 데이터는 최종 사용자에게 노출되며, 악성 공격에 사용될 수 있습니다.\r\n", jsx(_components.code, {
        children: "textContent"
      }), "는 일반적으로는 필요하지 않지만, 일반적인 diffing 루틴을 건너뛰기 때문에 자식이 텍스트로만 구성되어 있다는 것을 알고 있는 경우 사용하면 성능을 최적화할 수 있습니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div textContent={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "text"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "on___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___",
        children: "#"
      }), jsx(_components.code, {
        children: "on___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Solid의 이벤트 핸들러는 일반적으로 스타일에 따라 ", jsx(_components.code, {
        children: "onclick"
      }), " 이나 ", jsx(_components.code, {
        children: "onClick"
      }), " 형식을 취합니다."]
    }), "\n", jsxs(_components.p, {
      children: ["Solid는 버블링되는 일반 UI 이벤트에 대해 반-합성", "semi-synthetic", " 이벤트 위임을 사용합니다.\r\n이로 인해 일반적인 이벤트의 성능이 향상됩니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div onClick={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentTarget"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Solid는 이벤트 핸들러의 첫 번째 인수에 값을 바인딩하기 위해 배열을 사용할 수 있습니다.\r\n이는 ", jsx(_components.code, {
        children: "bind"
      }), "를 사용하거나 추가 클로저를 생성하지 않으므로, 이벤트를 위임하는 고도로 최적화된 방법입니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "handler"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "itemId, e"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*...*/"
        }), "\r\n}\r\n\r\n<ul>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.list}"
            }), ">"]
          }), "{(item) => ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{[handler,"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), "]} />"]
          }), "}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), "\r\n</ul>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "이벤트는 리바운드되지 않으며 바인딩은 리액티브하지 않습니다. 이는 리스너를 추가, 삭제하는데 비용이 많이 들기 때문입니다.\r\n이벤트 핸들러는 이벤트 발생시마다 일반 함수처럼 호출되기 때문에 반응성이 필요없습니다; 원하는 경우 바로 가면 됩니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 정의된 경우 호출하며, 그렇지 않으면 호출하지 않음"
        }), "\r\n<div onClick={", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "handleClick"
        }), "?.()} />\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "onChange"
      }), "와 ", jsx(_components.code, {
        children: "onInput"
      }), "은 기본 동작에 따라 작동합니다. ", jsx(_components.code, {
        children: "onInput"
      }), "은 값이 변경된 직후 실행됩니다; ", jsx(_components.code, {
        children: "<input>"
      }), " 필드의 경우 ", jsx(_components.code, {
        children: "onChange"
      }), "는 필드가 포커스를 잃은 후에만 실행됩니다."]
    }), "\n", jsxs(_components.h2, {
      id: "on___oncapture___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___oncapture___",
        children: "#"
      }), jsx(_components.code, {
        children: "on:___"
      }), "/", jsx(_components.code, {
        children: "oncapture:___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["특이한 이름을 가진 이벤트나, 위임을 원하지 않는 이벤트의 경우 ", jsx(_components.code, {
        children: "on"
      }), " 네임스페이스 이벤트를 사용합니다.\r\n이 속성은 이벤트 리스너를 그대로 추가합니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "on"
        }), ":", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Weird"
        }), "-", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Event"
        }), "={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "alert"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "detail"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "use___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#use___",
        children: "#"
      }), jsx(_components.code, {
        children: "use:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "이는 커스텀 디렉티브입니다. 어떤 의미에서 이는 ref에 대한 문법적 설탕이지만 단일 엘리먼트에 여러 디렉티브를 쉽게 연결할 수 있습니다.\r\n디렉티브는 다음과 같은 시그니처를 가지는 함수입니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "directive"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["element: Element, accessor: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "디렉티브 함수는 DOM에 추가되기 전에 렌더링시에 호출됩니다.\r\n시그널, 이펙트 생성, 클린업 등록등을 포함하는 모든 원하는 작업을 수행할 수 있습니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [name, setName] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "el, value"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [field, setField] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "value"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRenderEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " (el.", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "field"
        }), "()));\r\n  el.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"input\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setField"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "target"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), "));\r\n}\r\n\r\n<input type=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"text\""
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "use"
        }), ":model={[name, setName]} />;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "타입스크립트 사용시 JSX 네임스페이스를 확장해 등록합니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-attr",
          children: "model"
        }), ": [", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "];\r\n    }\r\n  }\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "prop___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#prop___",
        children: "#"
      }), jsx(_components.code, {
        children: "prop:___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["prop이 속성", "attribute", " 대신 프로퍼티로 처리되도록 합니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "prop"
        }), ":scrollTop={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "scrollPos"
        }), " + ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"px\""
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "attr___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#attr___",
        children: "#"
      }), jsx(_components.code, {
        children: "attr:___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["prop이 프로퍼티 대신 속성", "attribute", "로 처리되도록 합니다.\r\n웹 컴포넌트에서 속성을 설정하려는 경우 유용합니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<my-element ", jsx(_components.span, {
          className: "hljs-attr",
          children: "attr"
        }), ":status={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "status"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "-once-",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#-once-",
        children: "#"
      }), jsx(_components.code, {
        children: "/* @once */"
      })]
    }), "\n", jsx(_components.p, {
      children: "Solid의 컴파일러는 JSX 표현식의 리액티브 래핑 및 지연 평가에 휴리스틱을 사용합니다.\r\n함수 호출, 프로퍼티 액세스, JSX가 포함되어 있다면 컴포넌트에 전달할 때는 getter로 래핑하고, 기본 엘리먼트에 전달하는 경우에는 이펙트로 래핑합니다."
    }), "\n", jsxs(_components.p, {
      children: ["이 휴리스틱과 그 한계를 알고 있으면 JSX 외부에서 액세스하여 절대 변경되지 않는 항목의 오버헤드를 줄일 수 있습니다.\r\n홀로 있는 변수는 절대 래핑되지 않습니다.\r\n또한 표현식 앞에 ", jsx(_components.code, {
        children: "/* @once */"
      }), " 주석 데코레이터를 추가하여 컴파일러가 래핑하지 않도록 할 수 있습니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "static"
        }), "={", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " state.", jsx(_components.span, {
          className: "hljs-property",
          children: "wontUpdate"
        }), "} />\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "이는 자식에도 적용됩니다."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), ">{", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " state.", jsx(_components.span, {
          className: "hljs-property",
          children: "wontUpdate"
        }), "}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), ">\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=api-94a4f910.js.map
